SystemOrganization addCategory: #'Seaside-Scaffolding'!
SystemOrganization addCategory: #'Seaside-Scaffolding-Model'!
SystemOrganization addCategory: #'Seaside-Scaffolding-Test'!
SystemOrganization addCategory: #'Seaside-Scaffolding-Component'!
SystemOrganization addCategory: #'Seaside-Scaffolding-Renderer'!

WAComponent subclass: #SGComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGComponent methodsFor: 'ajax' stamp: 'obi 6/20/2010 17:43'!
ajaxAdd: aComponent on: script
	self ajaxShow: (aComponent parent: self) on: script ! !

!SGComponent methodsFor: 'ajax' stamp: 'obi 6/20/2010 22:08'!
ajaxBackOn: script
	self parent isNil ifFalse: [self parent ajaxShow: self parent on: script ]! !

!SGComponent methodsFor: 'ajax' stamp: 'obi 6/20/2010 16:31'!
ajaxShow: aComponent on: script
	script << (script jQuery: self containerId asSymbol) html: aComponent! !

!SGComponent methodsFor: 'convenience' stamp: 'obi 11/08/2008 10:03'!
confirm: aString
	"use lightbox instead of the default call:"
	^self lightbox: (WAYesOrNoDialog new
						addMessage: aString;
						yourself)! !

!SGComponent methodsFor: 'accessing' stamp: 'obi 6/20/2010 16:31'!
containerId
	^'center'! !

!SGComponent methodsFor: 'accessing' stamp: 'obi 6/20/2010 18:07'!
formId
	^nil! !

!SGComponent methodsFor: 'convenience' stamp: 'obi 11/25/2008 14:12'!
inform: aString
	"use lightbox instead of the default call:"
	^self lightbox: (WAFormDialog new
		addMessage: aString;
		yourself)! !

!SGComponent methodsFor: 'accessing' stamp: 'obi 6/26/2010 19:30'!
jqWidgetLibrary
	^JQWidgetBoxDeploymentLibrary! !

!SGComponent methodsFor: 'convenience' stamp: 'DataCurator 11/10/2008 12:04'!
title

	^'Scaffolding for GemStone/S'.
! !

!SGComponent methodsFor: 'convenience' stamp: 'DataCurator 11/10/2008 12:05'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self title.
! !

SGComponent subclass: #SGFormComponent
	instanceVariableNames: 'model editor parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

SGFormComponent subclass: #SGEditorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGEditorComponent class methodsFor: 'instance creation' stamp: 'obi 11/07/2008 14:33'!
on: aModel
	^self new model: aModel; yourself! !

!SGEditorComponent methodsFor: 'private' stamp: 'obi 11/07/2008 14:30'!
buildEditor
	^model open! !

!SGEditorComponent methodsFor: 'rendering' stamp: 'obi 12/28/2010 18:42'!
renderTitleOn: html
	html heading level2; with: 'Edit'! !

!SGFormComponent class methodsFor: 'instance creation' stamp: 'obi 11/08/2008 01:05'!
on: aModel
	^self new model: aModel; yourself! !

!SGFormComponent methodsFor: 'private' stamp: 'obi 11/08/2008 01:08'!
buildEditor
	^self subclassResponsibility! !

!SGFormComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:05'!
children
	^Array with: editor! !

!SGFormComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:05'!
editor
	editor ifNil: [editor := self buildEditor].
	^editor! !

!SGFormComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:05'!
model: aModel
	model := aModel! !

!SGFormComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 06:37'!
parent
	^parent
	! !

!SGFormComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 06:37'!
parent: aComponent
	parent := aComponent
	! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:05'!
renderActionsOn: html
	! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:05'!
renderBodyOn: html
	html render: self editor! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:05'!
renderContentOn: html
	self renderHeaderOn: html.
	self renderBodyOn: html.
	self renderActionsOn: html.
	self renderFooterOn: html.! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:05'!
renderFooterOn: html
	! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:11'!
renderHeaderOn: html
	html table: [
			html tableRow: [
				html tableData: [
					html anchor
						class: 'back';
						callback: [self answer];
						with: '<'].
				html tableData: [self renderTitleOn: html]]]! !

!SGFormComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 01:11'!
renderTitleOn: html
	html heading: model displayString! !

SGFormComponent subclass: #SGViewComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGViewComponent class methodsFor: 'instance creation' stamp: 'obi 11/08/2008 01:07'!
on: aModel
	^self new model: aModel; yourself! !

!SGViewComponent methodsFor: 'private' stamp: 'obi 11/08/2008 01:08'!
buildEditor
	^model show! !

!SGViewComponent methodsFor: 'rendering' stamp: 'obi 12/28/2010 18:43'!
renderTitleOn: html
	! !

SGComponent subclass: #SGFormDialog
	instanceVariableNames: 'result title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGFormDialog methodsFor: 'rendering' stamp: 'obi 11/21/2010 13:24'!
renderBodyOn: html
	! !

!SGFormDialog methodsFor: 'rendering' stamp: 'obi 11/21/2010 13:31'!
renderButtonsOn: html
	html break.
	html submitButton callback: [self answer: result]; value: 'OK'.
	html space.
	html submitButton callback: [self answer: nil]; value: 'Cancel'! !

!SGFormDialog methodsFor: 'rendering' stamp: 'obi 11/21/2010 13:50'!
renderContentOn: html
	html form
		class: 'dialog';
		with: [
			self renderTitleOn: html.
			self renderBodyOn: html.
			self renderButtonsOn: html]! !

!SGFormDialog methodsFor: 'rendering' stamp: 'obi 11/21/2010 13:39'!
renderTitleOn: html
	html div class: 'title'; with: title! !

!SGFormDialog methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:31'!
result
	^ result! !

!SGFormDialog methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:31'!
result: anObject
	^ result := anObject! !

!SGFormDialog methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:31'!
title
	^ title! !

!SGFormDialog methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:31'!
title: anObject
	title := anObject! !

SGFormDialog subclass: #SGListChooser
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGListChooser class methodsFor: 'instance creation' stamp: 'obi 11/21/2010 13:29'!
on: list
	^self new list: list; yourself! !

!SGListChooser methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:28'!
list
	^ list! !

!SGListChooser methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:28'!
list: anObject
	list := anObject! !

!SGListChooser methodsFor: 'rendering' stamp: 'obi 11/21/2010 13:29'!
renderBodyOn: html
	html select
		list: list;
		size: (list size min: 10);
		callback: [:value | result := value];
		labels: [:each | each displayString ]
	! !

SGListChooser subclass: #SGMultiListChooser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGMultiListChooser methodsFor: 'rendering' stamp: 'obi 11/21/2010 14:00'!
renderBodyOn: html
	html multiSelect
		list: list;
		size: (list size min: 10);
		callback: [:value | value isEmpty ifTrue: [result := nil] ifFalse: [ result := value ] ];
		labels: [:each | each displayString ]
	! !

SGComponent subclass: #SGInheritanceGraph
	instanceVariableNames: 'moRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGInheritanceGraph class methodsFor: 'accessing' stamp: 'obi 06/01/2009 10:59'!
canBeRoot
	^true! !

!SGInheritanceGraph methodsFor: 'convenience' stamp: 'obi 6/15/2010 21:43'!
classNamed: aSymbol

	^SGSystem classNamed: aSymbol! !

!SGInheritanceGraph methodsFor: 'initialize-release' stamp: 'obi 06/01/2009 11:01'!
initialize
	super initialize.
	moRenderer := self verticalNarrowTreeLayout! !

!SGInheritanceGraph methodsFor: 'accessing' stamp: 'obi 06/01/2009 10:59'!
moRenderer

   "Return the value of the instance variable 'moRenderer'."
   ^moRenderer
! !

!SGInheritanceGraph methodsFor: 'updating' stamp: 'obi 06/01/2009 10:59'!
moRenderer: newValue

   "Modify the value of the instance variable 'moRenderer'."
   moRenderer := newValue
! !

!SGInheritanceGraph methodsFor: 'rendering' stamp: 'obi 06/01/2009 11:11'!
renderContentOn: html
	html heading level2; with: 'Inheritance Graph'.
	html div
		style: 'position:relative;top:0px;left:0px;height:590px;width:840px;overflow:auto';
		with: [html render: moRenderer]! !

!SGInheritanceGraph methodsFor: 'initialize-release' stamp: 'obi 06/01/2009 10:59'!
sgModelTreeLayout: aClass on: aView
	^ aClass new
		roots: [ :element | Array with: (aView elementOf: SGModel)  ];
		children: [ :each | each subclasses asSortedCollection collect: [:ea | aView elementOf: ea]];
		yourself! !

!SGInheritanceGraph methodsFor: 'initialize-release' stamp: 'obi 06/01/2009 11:19'!
verticalNarrowTreeLayout
	| view |
	view := (self classNamed: #MOHtmlRenderer) new.
	view style: ((self classNamed: #MOHtmlClassShape) new actionBlock: [:each | self call: (SGEditClassPage on: each)]; yourself).
	view layout: (self sgModelTreeLayout: (self classNamed: #MOVerticalSpacedTreeLayout) on: view).
	view addAll: SGModel withAllSubclasses.
	^view! !

SGComponent subclass: #SGListComponent
	instanceVariableNames: 'table parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGListComponent class methodsFor: 'accessing' stamp: 'obi 11/08/2008 04:36'!
modelClass
	^self subclassResponsibility! !

!SGListComponent methodsFor: 'private' stamp: 'obi 11/08/2008 06:29'!
buildTable
	^self modelClass projectReportOn: self list! !

!SGListComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 04:47'!
children
	^Array with: table! !

!SGListComponent methodsFor: 'initialize-release' stamp: 'obi 11/08/2008 04:48'!
initialize
	super initialize.
	table := self buildTable.
	self onAnswer: [:result | self refresh].! !

!SGListComponent methodsFor: 'private' stamp: 'obi 11/20/2010 14:27'!
list
	^self modelClass instancesSorted! !

!SGListComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 04:48'!
modelClass
	^self class modelClass! !

!SGListComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 06:36'!
parent
	^parent
	! !

!SGListComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 06:37'!
parent: aComponent
	parent := aComponent
	! !

!SGListComponent methodsFor: 'initialize-release' stamp: 'obi 11/21/2010 13:22'!
refresh
	table rows: self list
! !

!SGListComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 04:50'!
renderContentOn: html
	self renderTableOn: html.
! !

!SGListComponent methodsFor: 'rendering-convenience' stamp: 'obi 11/08/2008 06:17'!
renderListActionsOn: html model: aModel
	! !

!SGListComponent methodsFor: 'rendering-convenience' stamp: 'obi 11/08/2008 06:04'!
renderListHeaderActionsOn: html model: aModel
	! !

!SGListComponent methodsFor: 'rendering-convenience' stamp: 'obi 11/08/2008 06:27'!
renderListOn: html
	| visibleReadAccesors otherSelectors headSelector |
	visibleReadAccesors := self modelClass allVisibleReadAccessors.
	headSelector := visibleReadAccesors first.
	otherSelectors := visibleReadAccesors copyFrom: 2 to: visibleReadAccesors size.
	html table
		class: 'list'; 
		with: [
		self list 
			do: [:model |
					html tableRow: 
							[html tableHeading
								with: [self renderListTitleOn: html model: model method: headSelector].
							html tableData: [
									self renderListHeaderActionsOn: html model: model  ]].
					 otherSelectors do: [:aSelector |
						html tableRow: 
							[html tableData colSpan: 99; with: (model perform: aSelector) ] ].
					self renderPrivateRowsOn: html model: model.
					html tableRow: 
							[html tableData colSpan: 99; with: [self renderListActionsOn: html model: model] ] ]	 ]! !

!SGListComponent methodsFor: 'rendering-convenience' stamp: 'obi 11/08/2008 06:27'!
renderListTitleOn: html model: aModel method: headSelector
	html anchor callback: [WARenderLoop new call: (aModel perform: self modelClass defaultShowAction)]; with: (aModel perform: headSelector)! !

!SGListComponent methodsFor: 'rendering-convenience' stamp: 'obi 11/08/2008 06:23'!
renderPrivateRowsOn: html model: aModel
	! !

!SGListComponent methodsFor: 'rendering' stamp: 'obi 11/08/2008 04:50'!
renderTableOn: html
	html render: table! !

!SGListComponent methodsFor: 'private' stamp: 'obi 11/08/2008 05:49'!
rows: rows
	table isNil ifFalse: [table rows: rows]! !

!SGListComponent methodsFor: 'accessing' stamp: 'obi 11/08/2008 04:48'!
table
	^table! !

SGComponent subclass: #SGLogin
	instanceVariableNames: 'password project mandator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGLogin class methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:35'!
canBeRoot
	^true! !

!SGLogin class methodsFor: 'accessing' stamp: 'obi 11/25/2008 14:50'!
initialize
	^(self registerAsApplication: 'scaffolding/login')
		addLibrary: SGLibrary;
		addLibrary: SULibrary;		
     	preferenceAt: #sessionClass put: SGSession;
		yourself! !

!SGLogin methodsFor: 'actions' stamp: 'obi 11/25/2008 14:49'!
login
	| aUser aComponentClass |
	aUser := self session user.
	aUser isNil ifTrue: [^self inform: 'Unkown user - try again!!'].
	aUser password = password
		ifFalse: [^self inform: 'Invalid password - try again!!'].
		
	aComponentClass := project componentClass.
	aComponentClass isNil ifTrue: [^self inform: 'Component class "' , project componentClassName ,'" not found!!'].
	
	"set mandator which is used for this session"
	self session mandator: mandator.
	"open my application"
	self call: aComponentClass new
	
	
! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 14:26'!
mandator
	^mandator! !

!SGLogin methodsFor: 'private' stamp: 'obi 11/20/2010 14:28'!
mandators
	^SGMandator instancesSorted! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:59'!
password
	^password! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:59'!
password: aString
	password := aString! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 14:26'!
project
	^project! !

!SGLogin methodsFor: 'private' stamp: 'obi 11/20/2010 14:28'!
projects
	^SGProject instancesSorted! !

!SGLogin methodsFor: 'rendering' stamp: 'obi 11/25/2008 14:27'!
renderContentOn: html

	html table
		style: 'width:100%';
		with: [
			html tableRow: [
			html tableData align: 'center'; with: [
				
			html div class: 'login rounded';
				with: [
				html heading: 'Scaffolding Login'.
				html break.
	
				html form: [
					html table: [
						html tableRow: [
							html tableHeading: 'User'.
							html tableData: [html textInput on: #userName of: self session]].
						
						html tableRow: [
							html tableHeading: 'Password'.
							html tableData: [html passwordInput on: #password of: self]].
						
						html tableRow: [
							html tableHeading: 'Mandator'.
							html tableData: [
								html select
									list: self mandators;
									labels: [:each | each displayName];
									callback: [:value | mandator := value]]].
						
						html tableRow: [
							html tableHeading: 'Project'.
							html tableData: [
								html select
									list: self projects;
									labels: [:each | each displayName];
									callback: [:value | project := value]]].
						html tableRow: [
							html tableData
								align: 'center'; 
								colSpan: 99;
								with: [html break. html submitButton value: 'Login'; callback: [self login]]]]]]]]]! !

SGComponent subclass: #SGMain
	instanceVariableNames: 'navigation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGMain class methodsFor: 'initialize-release' stamp: 'obi 11/21/2010 11:18'!
initialize
	^(WAAdmin register: self asApplicationAt: 'scaffolding/main')
		addLibrary: SGLibrary;
     		preferenceAt: #sessionClass put: SGSession;
		yourself! !

!SGMain methodsFor: 'accessing' stamp: 'obi 11/21/2010 11:41'!
children
	^Array with: navigation! !

!SGMain methodsFor: 'initialize-release' stamp: 'obi 11/22/2010 22:55'!
createNavigation
| menu1 |
	navigation := SGNavigation new.
	menu1 := SGMenuItem label: 'Project'.
	menu1 add: (SGMenuItem on: [SGProject defaultReport] label: 'Show').
	menu1 add: (SGMenuItem on: [SGProject newEdit] label: 'Create new').
	navigation addItem: menu1.
	menu1 := SGMenuItem label: 'Classes'.
	menu1 add: (SGMenuItem on: [SGClassOverview new] label: 'Show all').
	menu1 add: (SGMenuItem on: [SGCreateClassPage new] label: 'Create new').
	menu1 add: (SGMenuItem on: [SGClassExplorer new] label: 'Tree').
"	(SGSystem classNamed: #MOHtmlRenderer) isNil ifFalse: [menu1 add: (SGMenuItem on: [SGInheritanceGraph new] label: 'Inheritance Graph')]."
	navigation addItem: menu1.
	menu1 := SGMenuItem label: 'Instances'.
	menu1 add: (SGMenuItem on: [SGInstanceOverview new] label: 'Show list').
	navigation addItem: menu1.
	menu1 := SGMenuItem label: 'User'.
	menu1 add: (SGMenuItem on: [SGUser defaultReport] label: 'Show').
	menu1 add: (SGMenuItem on: [SGUser newEdit] label: 'Create new').
	navigation addItem: menu1.	
	menu1 := SGMenuItem label: 'Group'.
	menu1 add: (SGMenuItem on: [SGGroup defaultReport] label: 'Show').
	menu1 add: (SGMenuItem on: [SGGroup newEdit] label: 'Create new').
	navigation addItem: menu1.
	menu1 := SGMenuItem label: 'Tenants'.
	menu1 add: (SGMenuItem on: [SGMandator defaultReport] label: 'Show').
	menu1 add: (SGMenuItem on: [SGMandator newEdit] label: 'Create new').
	navigation addItem: menu1.
	menu1 := SGMenuItem label: 'Info'.
	menu1 add: (SGMenuItem on: [SGHelpPage new] label: 'About').
	menu1 add: (SGMenuItem on:[SGCreditsPage new] label: 'Credits').
	menu1 add: (SGMenuItem on: [SGLicensePage new] label: 'License').
	navigation addItem: menu1.
	navigation selection: menu1 first
	! !

!SGMain methodsFor: 'initialize-release' stamp: 'obi 11/21/2010 11:44'!
initialize
	super initialize.
	self createNavigation! !

!SGMain methodsFor: 'rendering' stamp: 'obi 11/21/2010 11:41'!
renderContentOn: html
	self renderTitleOn: html.
	html render: navigation.
! !

!SGMain methodsFor: 'rendering' stamp: 'obi 11/21/2010 11:20'!
renderTitleOn: html
	html div class: 'maintitle'; with: 'Scaffolding for Seaside 3.x'! !

SGComponent subclass: #SGNavigation
	instanceVariableNames: 'items selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:14'!
add: anAction label: aLabel
	"Add anAction to the collection of child items. Answer an instance of SUNavigationItem."

	^ items add: (self navigationItemClass on: anAction label: aLabel)! !

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:18'!
addItem: anItem
	items add: anItem! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:58'!
children
	selection ifNil: [^#()].
	^Array with: selection component! !

!SGNavigation methodsFor: 'actions' stamp: 'obi 10/30/2008 15:48'!
execute: menuItem
	selection := menuItem.
	menuItem execute! !

!SGNavigation methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:00'!
initialize
	super initialize.
	items := OrderedCollection new! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 14:59'!
items
 ^items! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:00'!
navigationItemClass
	"Answer the navigation class to represent the child items."

	^ SGMenuItem! !

!SGNavigation methodsFor: 'rendering' stamp: 'obi 11/21/2010 12:30'!
renderContentOn: html
	
	html table class: 'page';
		with: [
			html tableRow: [
				html tableData
					verticalAlign: 'top';
					with: [ self renderNavigationOn: html ].
				html tableData
					verticalAlign: 'top';
					class: 'contents';
					with: [ html render: selection ] ] ]

	! !

!SGNavigation methodsFor: 'rendering' stamp: 'obi 11/21/2010 11:56'!
renderNavigationOn: html

html div class: 'navigation';
	with: [
		items do: [:menuItem |
			menuItem action isNil
			ifTrue: [
				html div
					class: 'title';
					with: menuItem label]
			ifFalse: [html div
					class: 'title';
					with: [
				html anchor
					callback: [self selection: menuItem];
					with: menuItem label]].
		html div
			class: 'list';
			with: [menuItem subItems
						do: [:subMenu | 
							html div class: 'item';	
								with: [subMenu label
										isEmpty 
											ifTrue: [html break]
											ifFalse: [
												html anchor
													callback: [self selection: subMenu];
													with: subMenu label] ] ] ].
		menuItem subItems isEmpty ifFalse: [ html break ] ] ]
	 
! !

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:30'!
selectFirst
	items isEmpty ifFalse: [self selection: items first]! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:49'!
selection
	^selection
	! !

!SGNavigation methodsFor: 'actions' stamp: 'obi 10/30/2008 15:54'!
selection: menuItem
	selection := menuItem.
	menuItem execute! !

SGComponent subclass: #SGProjectComponent
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGProjectComponent class methodsFor: 'accessing' stamp: 'obi 11/04/2008 14:27'!
listActions
	^self modelClass defaultListActions! !

!SGProjectComponent class methodsFor: 'accessing' stamp: 'DataCurator 11/08/2008 00:36'!
modelClass
	^SGProject! !

!SGProjectComponent methodsFor: 'private' stamp: 'obi 11/08/2008 10:40'!
buildTable
	^self modelClass listClass new parent: self; yourself! !

!SGProjectComponent methodsFor: 'private' stamp: 'obi 11/08/2008 05:12'!
buildTable2
	^self modelClass projectReport! !

!SGProjectComponent methodsFor: 'accessing' stamp: 'obi 11/04/2008 14:52'!
children
	^Array with: table! !

!SGProjectComponent methodsFor: 'initialize-release' stamp: 'obi 11/05/2008 09:48'!
initialize
	super initialize.
	table := self buildTable.
	self onAnswer: [:result | self refresh].! !

!SGProjectComponent methodsFor: 'accessing' stamp: 'obi 11/04/2008 14:29'!
modelClass
	^self class modelClass! !

!SGProjectComponent methodsFor: 'private' stamp: 'obi 11/20/2010 14:26'!
refresh
	table rows: self modelClass instances
! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/05/2008 09:50'!
renderActionsOn: html
	html break.
	self class listActions
		do: [:anAction |
				html anchor
					class: 'action';
					callback: [
							self call: (self modelClass perform: anAction key).
							self refresh];
					with: anAction value]
		separatedBy: [html space]
	! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/04/2008 14:32'!
renderBodyOn: html
	self renderTableOn: html! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/04/2008 14:18'!
renderContentOn: html
	self renderIndexOn: html.
	self renderBodyOn: html.
	self renderActionsOn: html.! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/04/2008 14:31'!
renderIndexOn: html
	self renderTitleOn: html! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/04/2008 14:35'!
renderTableOn: html
	html render: table! !

!SGProjectComponent methodsFor: 'rendering' stamp: 'obi 11/04/2008 14:31'!
renderTitleOn: html
	html heading: self modelClass displayString! !

!SGProjectComponent methodsFor: 'accessing' stamp: 'obi 11/04/2008 14:32'!
table
	^table! !

SGComponent subclass: #SGSubComponent
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

SGSubComponent subclass: #SGClassExplorer
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGClassExplorer class methodsFor: 'testing' stamp: 'obi 05/18/2009 13:44'!
canBeRoot
	^true! !

!SGClassExplorer methodsFor: 'initialize-release' stamp: 'obi 11/21/2010 20:03'!
buildTree
	^ WATree new
		root: SGModel;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		selectBlock: [:class | self call: class edit];
		yourself
! !

!SGClassExplorer methodsFor: 'accessing' stamp: 'obi 11/21/2010 20:03'!
children
	^Array with: tree
! !

!SGClassExplorer methodsFor: 'initialize-release' stamp: 'obi 11/21/2010 20:03'!
initialize
	super initialize.
	tree := self buildTree
	
! !

!SGClassExplorer methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:23'!
renderContentOn: html
	html heading level2; with: 'Class Tree'.
	html div class: 'tree';
		with: [ html render: tree ].! !

!SGClassExplorer methodsFor: 'accessing' stamp: 'obi 6/26/2010 19:34'!
title
	^'Class tree'! !

SGSubComponent subclass: #SGClassOverview
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGClassOverview class methodsFor: 'testing' stamp: 'obi 05/18/2009 13:34'!
canBeRoot
	^true! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 11/21/2010 14:51'!
allClasses
	^SGModel withAllSubclasses asSortedCollection asOrderedCollection! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 6/14/2010 22:35'!
buildTable
	| report |
	report := MAReport new
		rowPeriod: 1;
		batchSize: 25;
		rows: self allClasses.
	report
		addColumn:
			(MAColumn new
				accessor: #yourself;
				label: 'Class';
				yourself);
		addColumn:
			(MAColumn new
				accessor: #instancesSize;
				label: '# Instances';
				yourself);
		addColumn: self commandColumn.
	^report! !

!SGClassOverview methodsFor: 'accessing' stamp: 'obi 11/01/2008 10:32'!
children
	^Array with: table! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 6/14/2010 22:37'!
commandColumn
	^MAColumn new
				renderer: [:each :html | 
					each isBasic 
						ifTrue: [
							each canCreateSubclass
								ifFalse: [html space]
								ifTrue: [
									html anchor
										callback: [self newSubclass: each ];
										title: 'Create subclass';
										with: 'Create' ] ]
						ifFalse: [
							html anchor
								callback: [self edit: each ];
								title: 'Edit class';
								with: 'Edit'.
							html space.
							html anchor
								callback: [self newSubclass: each ];
								title: 'Create subclass';
								with: 'Create'  ]];
				label: 'Actions';
				yourself! !

!SGClassOverview methodsFor: 'actions' stamp: 'obi 6/14/2010 23:00'!
edit: aClass
	| result |
	result := self call: aClass edit.
	result == #delete ifTrue: [table rows remove: aClass. table refresh]! !

!SGClassOverview methodsFor: 'initialize-release' stamp: 'obi 11/01/2008 10:31'!
initialize
	super initialize.
	table := self buildTable
	! !

!SGClassOverview methodsFor: 'actions' stamp: 'obi 6/14/2010 23:01'!
newSubclass: aClass
	| result |
	result := self call: (SGCreateClassPage on: aClass).
	result isBehavior ifTrue: [
		table rows add: result.
		table refresh]! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 11/04/2008 11:29'!
refresh
	table rows: self allClasses
! !

!SGClassOverview methodsFor: 'rendering' stamp: 'obi 05/18/2009 13:40'!
renderContentOn: html
	html heading level2; with: 'Class Administration'.
	html render: table! !

SGClassOverview subclass: #SGInstanceOverview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGInstanceOverview methodsFor: 'private' stamp: 'obi 6/15/2010 22:56'!
commandColumn
	^MAColumn new
				renderer: [:each :html | 
					each isBasic 
						ifTrue: [html anchor
									callback: [self listInstances: each ];
									title: 'List instances';
									with: 'List'.]
						ifFalse: [
							html anchor
									callback: [self listInstances: each ];
									title: 'List instances';
									with: 'List'.
							html space.
							html anchor
									callback: [self newInstance: each ];
									title: 'Create new instance';
									with: 'New' ] ];
				label: 'Actions';
				yourself! !

!SGInstanceOverview methodsFor: 'actions' stamp: 'obi 11/04/2008 11:39'!
listInstances: aClass
	self call: aClass defaultReport! !

!SGInstanceOverview methodsFor: 'actions' stamp: 'obi 11/04/2008 11:39'!
newInstance: aClass
	self call: aClass newEdit! !

!SGInstanceOverview methodsFor: 'rendering' stamp: 'obi 05/18/2009 13:53'!
renderContentOn: html
	html heading level2; with: 'Show Instances'.
	html render: table.
	! !

SGSubComponent subclass: #SGCreditsPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGCreditsPage methodsFor: 'rendering' stamp: 'obi 11/22/2010 21:59'!
renderContentOn: html
	html heading: 'Credits'.
	html unorderedList: [
		html listItem: [
			html anchor
				url: 'http://www.avibryant.com/';
				with: 'Avi Bryant'.
			html text: ' for creating Seaside'.
		].
		html listItem: [
			html anchor
				url: 'http://www.lukas-renggli.ch/';
				with: 'Lukas Renggli'.
			html text: ' for creating Magritte'.
		].
		html listItem: [
			html anchor
				url: 'http://gemstonesoup.wordpress.com/';
				with: 'Dale Henrichs'.
			html text: ' for porting Seaside to GemStone/S'.
		].
		html listItem: [
			html anchor
				url: 'http://seaside.gemstone.com/ss/ScaffoldingGS.html';
				with: 'Gerhard Obermann'.
			html text: ' for creating Scaffolding for Seaside'.
		].
	].
! !

!SGCreditsPage methodsFor: 'rendering' stamp: 'DataCurator 11/10/2008 12:05'!
title

	^super title , ' -- Credits'.
! !

SGSubComponent subclass: #SGEditPage
	instanceVariableNames: 'formId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

SGEditPage subclass: #SGChangeType
	instanceVariableNames: 'theClass description selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGChangeType class methodsFor: 'instance creation' stamp: 'obi 11/03/2008 11:35'!
on: theClass description: desc
	^self new theClass: theClass; description: desc; yourself! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:27'!
description

   "Return the value of the instance variable 'description'."
   ^description
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:39'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue.
	selection := description class
! !

!SGChangeType methodsFor: 'accessing-configuration' stamp: 'obi 04/19/2009 11:01'!
descriptionClasses
	^ OrderedCollection new
		add: MAStringDescription;
		add: MAMemoDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: MABooleanDescription;
		add: MASingleOptionDescription;
		add: MAMultipleOptionDescription;
		add: MAToOneRelationDescription;
		add: MAToManyRelationDescription;
		add: SGTwowayRelationDescription;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: MAColorDescription;
		add: MATokenDescription;
		add: MAFileDescription;
		add: MAClassDescription;
		add: MATableDescription;
		yourself! !

!SGChangeType methodsFor: 'rendering' stamp: 'obi 11/04/2008 11:17'!
renderFormOn: html
	html heading: 'Change type for attribute: ', description accessor readSelector.
	html select list: self descriptionClasses; labels: [:each | each label]; on: #selection of: self.
	html break! !

!SGChangeType methodsFor: 'actions' stamp: 'obi 6/15/2010 22:18'!
save
	| newDescription oldIndex |
	newDescription := theClass descriptionOn: description accessor readSelector type: selection.
	newDescription priority: description priority.
	newDescription readonly: description readonly.
	newDescription required: description required.
	newDescription group: description group.
	newDescription comment: description comment.
	"fix for Magritte 1:m relations"
	"if default is not set, the table in the magritte editor for such descriptions will fail"
	(newDescription isKindOf: MAToManyRelationDescription) ifTrue: [newDescription default: OrderedCollection new].
	"end fix"
	(newDescription isKindOf: MAToManyRelationDescription) ifTrue: [newDescription classes: SGModel noneBasicClasses].
	oldIndex := theClass attributeContainer children indexOf: description.
	theClass descriptionAt: oldIndex put: newDescription.
	self answer: newDescription! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:36'!
selection

   "Return the value of the instance variable 'selection'."
   ^selection
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:36'!
selection: newValue

   "Modify the value of the instance variable 'selection'."
   selection := newValue
! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:27'!
theClass

   "Return the value of the instance variable 'theClass'."
   ^theClass
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:27'!
theClass: newValue

   "Modify the value of the instance variable 'theClass'."
   theClass := newValue
! !

SGEditPage subclass: #SGCreateClassPage
	instanceVariableNames: 'list selection name attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGCreateClassPage class methodsFor: 'instance creation' stamp: 'obi 11/02/2008 09:34'!
on: aSuperclass
	^self new selection: aSuperclass; yourself! !

!SGCreateClassPage methodsFor: 'private' stamp: 'obi 6/14/2010 22:23'!
attributesArray
	^attributes isEmpty
		ifTrue: [#()]
		ifFalse: [(attributes findTokens: $;) collect: [:str | str withBlanksTrimmed]]! !

!SGCreateClassPage methodsFor: 'initialize-release' stamp: 'obi 6/20/2010 21:08'!
initialize
	super initialize.
	list := SGModel withAllSubclasses select: [:cl | cl canCreateSubclass ]! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:27'!
list
	^list! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:27'!
list: aCollection
	list := aCollection! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:22'!
name
	^name! !

!SGCreateClassPage methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:16'!
renderFormOn: html
	html table: 
		[html tableRow: [
			html tableHeading: 'Superclass'.
			html tableData: [html select list: self list; on: #selection of: self].
		html tableRow: [
			html tableHeading: 'Name'.
			html tableData: [html textInput callback: [:value | name := value] ] ].
		html tableRow: [
			html tableHeading: 'Attributes'.
			html tableData: [html textArea callback: [:value | attributes := value] ] ] ] ]
	! !

!SGCreateClassPage methodsFor: 'actions' stamp: 'obi 6/14/2010 23:04'!
save
	| newClass |
	selection isNil ifFalse: [
		name isEmpty ifFalse: [
			newClass := selection subclass: name instVarNames: (self attributesArray).
			newClass isNil ifFalse: [self home; call: newClass edit.
									newClass := SGSystem classNamed: newClass name.
									self answer: newClass ] ] ]! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/02/2008 11:16'!
selection
	^selection! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/02/2008 09:39'!
selection: aClass
	selection := aClass! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:47'!
title
	^'Create Subclass'! !

SGEditPage subclass: #SGEditClassPage
	instanceVariableNames: 'theClass classComment attributes descTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGEditClassPage class methodsFor: 'instance creation' stamp: 'obi 11/03/2008 10:45'!
on: aClass
	^self new theClass: aClass; yourself! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/01/2008 11:48'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
	attributes := newValue.! !

!SGEditClassPage methodsFor: 'private' stamp: 'obi 6/14/2010 22:51'!
attributesArray
	^attributes isEmpty
		ifTrue: [#()]
		ifFalse: [(attributes findTokens: $;) collect: [:str | str withBlanksTrimmed]]! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 11:38'!
attributesChanged
   ^theClass attributesAsString ~= attributes
! !

!SGEditClassPage methodsFor: 'private' stamp: 'obi 11/03/2008 11:25'!
buildDescriptionTable
	descTable := MAReport
		rows: theClass attributeDescriptions
		description: (MAElementDescription description reject: [:desc | desc isKindOf: MAReferenceDescription]).
	descTable addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'Edit';
			addCommandOn: self selector: #changeType: text: 'Change';
			addCommandOn: self selector: #moveUp: text: '/\';
			addCommandOn: self selector: #moveDown: text: '\/';
			yourself).
	^descTable! !

!SGEditClassPage methodsFor: 'private' stamp: 'obi 11/03/2008 11:17'!
buildEditorFor: anObject titled: aString
	^ anObject asComponent
		addValidatedForm;
		addMessage: aString;
		yourself! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 6/14/2010 22:49'!
buttons
	| array |
	array := OrderedCollection new.
	theClass canEdit ifTrue: [
			array add: #save -> 'Save'].
	theClass canCreateSubclass ifTrue: [array add: #create -> 'Create subclass'].
	theClass canEdit ifTrue: [
			array add: #delete -> 'Delete'].
	array add: #cancel -> 'Cancel'.
	^array! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 6/15/2010 22:00'!
changeType: aDescription
	self call: (SGChangeType on: theClass description: aDescription).
	theClass compileDescriptionMethods.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/03/2008 11:08'!
children
	^Array with: descTable! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
classComment

   "Return the value of the instance variable 'classComment'."
   ^classComment
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/01/2008 09:42'!
classComment: newValue

   "Modify the value of the instance variable 'classComment'."
   classComment := newValue
! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/02/2008 11:31'!
create
	theClass isNil ifFalse: [self call: (SGCreateClassPage on: theClass)]! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/01/2008 12:09'!
delete
	| result |
	theClass isNil ifFalse: [
		(self confirm: 'Really delete ', theClass name asString)
			ifTrue: [
				theClass canDelete ifFalse: [^self inform: 'Delete is not possible -> Class has instances!!'].
				SGSystem removeClassNamed: theClass name check: false.
				self answer: #delete]]! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/03/2008 10:59'!
descTable
	descTable ifNil: [self buildDescriptionTable].
	^descTable! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 6/15/2010 22:03'!
editDescription: aDescription
	(aDescription isKindOf: MARelationDescription)
		ifTrue: [
			self call: (SGRelationDescriptionEditor
				on: aDescription
				titled: 'Edit ' , aDescription class label)]
		ifFalse: [
			self call: (self
				buildEditorFor: aDescription
				titled: 'Edit ' , aDescription class label)].
	theClass compileDescriptionMethods.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'initialize-release' stamp: 'obi 11/03/2008 10:46'!
initialize
	super initialize.
	! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/03/2008 11:57'!
moveDown: aDescription
	theClass description moveDown: aDescription.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/03/2008 11:56'!
moveUp: aDescription
	theClass description moveUp: aDescription.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'rendering' stamp: 'obi 11/03/2008 11:00'!
renderFormOn: html
	html table: 
		[html tableRow: [
			html tableHeading: 'Superclass'.
			html tableData: [
				theClass name == #SGModel
					ifTrue: [html text: theClass superclass]
					ifFalse: [self renderLinkTo: theClass superclass on: html ] ] ].
		html tableRow: [
			html tableHeading: 'Name'.
			html tableData: [html text: theClass name] ].
		html tableRow: [
			html tableHeading: 'Comment'.
			html tableData: [html textArea columns: 60; on: #classComment of: self ] ].
		html tableRow: [
			html tableHeading: 'Attributes'.
			html tableData: [html textArea columns: 60; on: #attributes of: self ] ].
		html tableRow: [
			html tableHeading: 'Subclasses'.
			html tableData: [theClass subclasses
								do: [:cl | self renderLinkTo: cl on: html ]
								separatedBy: [html space] ] ].
		
		 ] .
		html heading level3; with: 'Attribute descriptions'.
		html render: self descTable
	! !

!SGEditClassPage methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:39'!
renderLinkTo: aClass on: html
	html anchor
		callback: [self call: aClass edit];
		with: aClass name! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 6/14/2010 23:14'!
save
	| result |
	theClass isNil ifFalse: [
		theClass comment: classComment.
		self attributesChanged
			ifTrue: [
				theClass := theClass superclass subclass: theClass name instVarNames: self attributesArray.
				self theClass: theClass ].
		theClass compileDescriptionMethods]! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
theClass

   "Return the value of the instance variable 'theClass'."
   ^theClass
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/03/2008 10:59'!
theClass: newValue
	theClass := newValue.
	self attributes: theClass attributesAsString.
	self classComment: theClass comment.
	self buildDescriptionTable
! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 09:39'!
title
	^'Edit class description'! !

!SGEditPage class methodsFor: 'instance creation' stamp: 'obi 11/01/2008 09:35'!
title: aString
	^self new title: aString; yourself! !

!SGEditPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 11:28'!
buttons
	^Array with: #save -> 'Save' with: #cancel -> 'Cancel'! !

!SGEditPage methodsFor: 'actions' stamp: 'obi 11/01/2008 11:09'!
cancel
	self answer: false! !

!SGEditPage methodsFor: 'accessing' stamp: 'obi 6/20/2010 18:07'!
formId
	^formId! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:49'!
renderButtonsOn: html
	self buttons do: [:anAssoc | 
		html submitButton value: anAssoc value; callback: [self perform: anAssoc key].
		html space ].

	! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:35'!
renderContentOn: html
	html heading: self title.
	html form: 
		[self renderFormOn: html.
		self renderButtonsOn: html]! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:35'!
renderFormOn: html
	! !

!SGEditPage methodsFor: 'actions' stamp: 'obi 11/01/2008 11:09'!
save
	self answer: true! !

!SGEditPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 09:35'!
title
	^''! !

SGEditPage subclass: #SGProjectPage
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGProjectPage class methodsFor: 'instance creation' stamp: 'obi 11/05/2008 10:47'!
on: aModel
	^self new model: aModel; yourself! !

!SGProjectPage methodsFor: 'accessing' stamp: 'obi 11/08/2008 09:39'!
buttons
	^Array with: #save -> 'Save' with: #cancel -> 'Cancel' with: #delete -> 'Delete'! !

!SGProjectPage methodsFor: 'actions' stamp: 'obi 11/08/2008 10:00'!
delete
	"remove maybe all component classes too"
	(self confirm: 'Delete project: ', model displayString)
		ifTrue: [
			model discard.
			self answer: #delete]
	! !

!SGProjectPage methodsFor: 'private' stamp: 'obi 6/16/2010 20:59'!
entryPointUrl
	^WADispatcher default name! !

!SGProjectPage methodsFor: 'accessing' stamp: 'obi 11/05/2008 10:47'!
model
	^model! !

!SGProjectPage methodsFor: 'accessing' stamp: 'obi 11/05/2008 10:47'!
model: aModel
	model := aModel! !

!SGProjectPage methodsFor: 'rendering' stamp: 'obi 01/06/2009 05:28'!
renderFormOn: html
	html table: 
		[html tableRow: [
			html tableHeading: 'Name'.
			html tableData: [html textInput on: #name of: model] ].
		html tableRow: [
			html tableHeading: 'Path'.
			html tableData: [html textInput on: #path of: model] ].
		html tableRow: [
			html tableHeading: 'Description'.
			html tableData: [html textArea columns: 60; on: #description of: model] ].
		html tableRow: [
			html tableHeading: 'Model class'.
			html tableData: [html textInput on: #modelClass of: model] ].
		html tableRow: [
			html tableHeading: 'Project Link'.
			html tableData: [model name
								isNil
									ifTrue: [html space]
									ifFalse: [html anchor url: self entryPointUrl, model entryPoint; with: 'Open'] ] ].
		
		 ] .

	! !

!SGProjectPage methodsFor: 'actions' stamp: 'obi 11/08/2008 09:57'!
save
	(SGSystem classNamed: model modelClass)
		ifNil: [^self inform: 'Class: ', model modelClass , ' doesn''t exists!!'.
				].
	model save.
	super save! !

!SGProjectPage methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:28'!
title
	^'Editing Project: ', model displayString! !

SGEditPage subclass: #SGRelationDescriptionEditor
	instanceVariableNames: 'description label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGRelationDescriptionEditor class methodsFor: 'instance creation' stamp: 'obi 01/06/2009 05:25'!
on: aDescription titled: aString
	^self new description: aDescription; label: aString; yourself! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 04/21/2009 12:57'!
booleanAttributes
	^#(#readonly #visible #required #sorted #ordered)! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:24'!
description

   "Return the value of the instance variable 'description'."
   ^description
! !

!SGRelationDescriptionEditor methodsFor: 'updating' stamp: 'obi 01/06/2009 05:24'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue
! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 01/06/2009 05:40'!
descriptionFor: aSelector
	^description detect: [:desc | desc accessor readSelector = aSelector] ifNone: []! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:24'!
label

   "Return the value of the instance variable 'label'."
   ^label
! !

!SGRelationDescriptionEditor methodsFor: 'updating' stamp: 'obi 01/06/2009 05:24'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue
! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 04/21/2009 12:56'!
renderCheckboxRowFor: aSelector on: html
	(description respondsTo: aSelector)
		ifTrue: [
			html tableRow: [
				html tableHeading: aSelector asString capitalized.
				html tableData: [html checkbox on: aSelector of: description] ] ].! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 01/06/2009 06:07'!
renderFormOn: html
	html table: 
		[self stringAttributes do: [:aSelector | self renderRowFor: aSelector on: html].
		self booleanAttributes do: [:aSelector | self renderCheckboxRowFor: aSelector on: html].
		
		html tableRow: [
				html tableHeading: 'Classes'.
				html tableData: [
					html multiSelect
						list: SGModel allUserClasses;
						size: 10;
						selected: description classes;
						callback: [:value | description classes: value]]].

		
		 ] .

	! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 04/21/2009 12:57'!
renderRowFor: aSelector on: html
	(description respondsTo: aSelector)
		ifTrue: [
			html tableRow: [
				html tableHeading: aSelector asString capitalized.
				html tableData: [html textInput on: aSelector of: description] ] ].! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 04/21/2009 12:54'!
stringAttributes
	^#(#label #group #comment #priority #targetSelector)! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:26'!
title
	^self label! !

SGSubComponent subclass: #SGHelpPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGHelpPage methodsFor: 'rendering' stamp: 'obi 11/22/2010 22:38'!
renderContentOn: html
	html heading: 'About'.
	html heading level2; with: 'What is Scaffolding for Seaside?'.
	html paragraph: [
		html text: 'Many web application frameworks provide a built-in capability to create, 
retrieve (or view), update (or edit), and delete records in a database (the so-called '.
		html anchor
			url: 'http://en.wikipedia.org/wiki/Create,_read,_update_and_delete';
			with: 'CRUD'.
		html text: ' functionality). This capability, which has come to be called "scaffolding," 
generally requires little or no programming and is a staple of demos (see '.
		html anchor
			url: '';
			with: 'Scaffolding for Seaside'.
		html text: ' for our example).'
	].
	html paragraph: [
		html text: 'The web framework '.
		html anchor
			url: 'http://www.seaside.st/';
			with: 'Seaside'.
		html text: ' does not include any scaffolding directly, though a couple add-ons are available for 
Cincom Smalltalk (see '.
		html anchor
			url: 'http://www.cincomsmalltalk.com/userblogs/cincom/blogView?content=seaside_info';
			with: 'WebVelocity'.
		html text: ' and '.
		html anchor
			url: 'http://seabreeze.heeg.de/';
			with: 'SeaBreeze'.
		html text: ').'
	].
	html paragraph: [
		html strong: 'Scaffolding for GemStone'.
		html text: ' is available as a Monticello package on '.
		html anchor
			url: 'http://www.squeaksource.com/Seaside30Addons';
			with: 'Squeaksource'.
		html text: ' and can be installed in a Pharo or GemStone/S system after '.
		html anchor
			url: 'http://seaside.gemstone.com/ss/GLASS.html';
			with: 'GLASS'.
		html text: '. Scaffolding for Seaside relies on '.
		html anchor
			url: 'http://www.lukas-renggli.ch/smalltalk/magritte';
			with: 'Magritte'.
		html text: ' to generate domain model classes and views on those models and uses e.g. '.
		html anchor
			url: 'http://seaside.gemstone.com/';
			with: 'GemStone/S'.
		html text: ' for persistence (which, as an object database, allows us to avoid '.
		html anchor
			url: 'http://en.wikipedia.org/wiki/Active_record_pattern';
			with: 'Active Record'.
		html text: ' and other attempts to solve the challenges involved in '.
		html anchor
			url: 'http://en.wikipedia.org/wiki/Object-relational_mapping';
			with: 'Object-relational mapping'.
		html text: ').'.
	].
! !

!SGHelpPage methodsFor: 'rendering' stamp: 'DataCurator 11/10/2008 12:05'!
title

	^super title , ' -- Help'.
! !

SGSubComponent subclass: #SGLicensePage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGLicensePage methodsFor: 'rendering' stamp: 'obi 11/25/2008 13:11'!
renderContentOn: html
	html heading: 'License'.
	html paragraph: [
		html text: 'Scaffolding for GemStone/S is released under the '.
		html anchor
			url: 'http://www.opensource.org/licenses/mit-license.php';
			with: 'MIT License'.
	].
! !

!SGLicensePage methodsFor: 'rendering' stamp: 'DataCurator 11/10/2008 12:05'!
title

	^super title , ' -- License'.
! !

!SGSubComponent methodsFor: 'accessing' stamp: 'obi 6/19/2010 21:15'!
parent
	^ parent! !

!SGSubComponent methodsFor: 'accessing' stamp: 'obi 6/19/2010 21:15'!
parent: anObject
	parent := anObject! !

MASingleOptionDescription subclass: #SGSingleOptionDescription
	instanceVariableNames: 'displayStringSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGSingleOptionDescription methodsFor: 'accessing' stamp: 'obi 12/29/2008 12:03'!
displayStringSelector

   "Return the value of the instance variable 'displayStringSelector'."
   ^displayStringSelector
! !

!SGSingleOptionDescription methodsFor: 'updating' stamp: 'obi 12/29/2008 12:03'!
displayStringSelector: newValue

   "Modify the value of the instance variable 'displayStringSelector'."
   displayStringSelector := newValue
! !

!SGSingleOptionDescription methodsFor: 'initialization' stamp: 'obi 12/29/2008 12:07'!
initialize
	super initialize.
	displayStringSelector := #displayString! !

!SGSingleOptionDescription methodsFor: 'private' stamp: 'obi 12/29/2008 12:07'!
labelForOption: anObject
	^anObject perform: displayStringSelector! !

!SGSingleOptionDescription methodsFor: 'accessing' stamp: 'obi 12/29/2008 12:05'!
options
	^ options isNil
		ifTrue: [#()]
		ifFalse: [options value]! !

WASession subclass: #SGSession
	instanceVariableNames: 'mandator user project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGSession methodsFor: 'initialize-release' stamp: 'obi 11/04/2008 07:49'!
initialize
	super initialize.
	mandator := SGMandator default! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/04/2008 07:48'!
mandator
	^mandator! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/04/2008 07:48'!
mandator: aMandator
	mandator := aMandator! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:29'!
project
	^project! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:29'!
project: aMandator
	project := aMandator! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:26'!
user
	^user! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:26'!
user: aUser
	user := aUser! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 14:17'!
userName
	^user isNil ifTrue: [''] ifFalse: [user loginName]! !

!SGSession methodsFor: 'accessing' stamp: 'obi 11/25/2008 14:17'!
userName: aName
	user := SGUser detect: [:each | each loginName = aName].
	^user! !

MASelectorAccessor subclass: #SGTwowayRelationAccessor
	instanceVariableNames: 'targetSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGTwowayRelationAccessor class methodsFor: 'accessing' stamp: 'obi 05/05/2009 13:27'!
relationClass
	^OrderedCollection! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/12/2009 13:08'!
add: anObject to: aModel
	| aColl |
	aColl := aModel perform: self readSelector.
	aColl isNil ifTrue: [super write: (aColl := self class relationClass new) to: aModel].
	(aColl includes: anObject)
		ifFalse: [
			aColl add: anObject.
			(anObject perform: targetSelector) add: aModel]
	
	
	! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/16/2009 12:24'!
addAll: aCollection to: aModel
	aCollection do: [:each | self add: each to: aModel]
	! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/05/2009 13:39'!
remove: anObject from: aModel
	"remove the objects from both collections"
	(aModel perform: self readSelector) remove: anObject ifAbsent: [].
	(anObject perform: targetSelector) remove: aModel ifAbsent: []! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/05/2009 13:30'!
removeAllFrom: aModel
	(aModel perform: readSelector) do: [:each | self remove: each from: aModel]! !

!SGTwowayRelationAccessor methodsFor: 'accessing' stamp: 'obi 04/21/2009 13:28'!
targetSelector 
	^targetSelector! !

!SGTwowayRelationAccessor methodsFor: 'accessing' stamp: 'obi 04/21/2009 13:27'!
targetSelector: aSymbol
	targetSelector := aSymbol! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/24/2009 10:32'!
write: anObject to: aModel
	| aColl |
	"add anObject to my collection and also add aModel to the other object collection 2"
	anObject ifNil: [^self removeAllFrom: aModel].
	(anObject isKindOf: Collection)
		ifTrue: [super write: anObject to: aModel]
		ifFalse: [self add: anObject to: aModel]! !

SequenceableCollection subclass: #SGTwowayRelation
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGTwowayRelation methodsFor: 'Adding' stamp: 'obi 04/14/2009 11:51'!
add: aModel withAttribute: aSymbol
	self add: (aModel perform: aSymbol)
	! !

!SGTwowayRelation methodsFor: 'printing' stamp: 'obi 04/20/2009 11:50'!
asString
	| result |
	result := String new.
	self targets do: [:model | result add: model asString] separatedBy: [result add: ', '].
	^result! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:25'!
elf size do: [ :i | (aBlock value: (self at: i) model) ifTrue: [^(self at: i) model]]. 
	^exceptionBlock value
! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'obi 04/14/2009 12:14'!
firstTarget
	self size == 0 ifTrue: [^nil].
	^(self at: 1) model! !

!SGTwowayRelation methodsFor: 'Searching' stamp: 'obi 04/14/2009 12:23'!
includesTarget: anObject
	1 to: self size do: [:i |
		  (anObject == (self at: i) model) ifTrue: [^true] ].

	^false
! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'obi 04/14/2009 11:48'!
model

   "Return the value of the instance variable 'model'."
   ^model
! !

!SGTwowayRelation methodsFor: 'updating' stamp: 'obi 04/14/2009 11:48'!
model: newValue

   "Modify the value of the instance variable 'model'."
   model := newValue
! !

!SGTwowayRelation methodsFor: 'printing' stamp: 'obi 04/20/2009 11:46'!
printOn: aStream
	self targets printOn: aStream! !

!SGTwowayRelation methodsFor: 'Removing' stamp: 'obi 04/14/2009 11:54'!
remove: aModel withAttribute: aSymbol
	self remove: aModel withAttribute: aSymbol ifAbsent: [self _errorNotFound: aModel]
	! !

!SGTwowayRelation methodsFor: 'Removing' stamp: 'obi 04/14/2009 11:53'!
remove: aModel withAttribute: aSymbol ifAbsent: aBlock
	self remove: (aModel perform: aSymbol) ifAbsent: aBlock
	! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:25'!
self size do: [ :i | (aBlock value: (self at: i) model) ifTrue: [^(self at: i) model]]. 
	^exceptionBlock value
! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'obi 04/17/2009 12:51'!
targets
	| result |
	result := OrderedCollection new.
	self targetsDo: [:model | result add: model].
	^result! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:26'!
targetsDetect: aBlock
	^self targetsDetect: aBlock ifNone: [].
! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:25'!
targetsDetect: aBlock ifNone: exceptionBlock

	1 to: self size do: [ :i | (aBlock value: (self at: i) model) ifTrue: [^(self at: i) model]]. 
	^exceptionBlock value
! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:19'!
targetsDo: aBlock
	1 to: self size do: [:idx | aBlock value: (self at: idx) model]! !

WAFileLibrary subclass: #SGLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGLibrary methodsFor: 'other' stamp: 'obi 11/22/2010 22:56'!
adminCss
	^'
	html {height:100%; overflow:hidden}
	body {margin: 0;padding: 0;border:0;overflow:hidden;height:100%;}
	body, div, tr, td, th, form input, select, form submit {font-family: verdana, Arial, Helvetica, sans-serif;font-size: 11px;}
	table, tr, td, th, form {margin:0;padding:0;border:0}
	th {text-align: left;}
	a {text-decoration:none;color:#369}
	a:hover {color:#69c}
	.navigation a {margin-left:6px}
	.tree ul {margin-left:6px;padding-left:8px}
	.dialog .title {font-size:120%;background:#888;color:#fff;padding:4px}
	.dialog {min-width:300px}
	.dialog select {min-width:300px}
	.maintitle {color:#fff;width:100%;padding-left:6px;
		font-size:18px;
		font-weight:bold;
		line-height:27px;
		height:27px;
		overflow:hidden;
		background: -webkit-gradient(
    linear,
    left bottom,
    left top,
    color-stop(0.11, rgb(141,167,214)),
    color-stop(0.82, rgb(76,95,212)) );
background: -moz-linear-gradient(
    center bottom,
    rgb(141,167,214) 11%,
    rgb(76,95,212) 82%
)}
table.page {width:100%}
.page .contents {padding:4px;width:100%}
.page .contents h2, .page .contents h1 {margin:0 0 0.5em 0}
.navigation {
	width:100px;
	margin-top:6px;
	margin-left:2px;
	padding:6px;
	-moz-border-radius: 5px;
	border-radius: 5px;
background: -webkit-gradient(
    linear,
    left bottom,
    left top,
    color-stop(0.11, rgb(207,215,247)),
    color-stop(0.82, rgb(235,239,245))
)}
	div#lightbox {padding:6px;border:1px solid #6bf;background:#fff;-moz-border-radius: 10px;-webkit-border-radius:10px;border-radius:10px;text-decoration:none;color:#666}
	body div#overlay {
	z-index: 9998;
	background-color: #369;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3}
'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 11/21/2010 15:38'!
buttonCss
	^'.page .contents td a {
	display: inline-block;
	outline: none;
	cursor: pointer;
	text-align: center;
	text-decoration: none;
	font: 11px/100% Arial, Helvetica, sans-serif;
	padding: .2em 1em .275em;
	text-shadow: 0 1px 1px rgba(0,0,0,.3);
	-webkit-border-radius: .5em;
	-moz-border-radius: .5em;
	border-radius: .5em;
	-webkit-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	-moz-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	box-shadow: 0 1px 2px rgba(0,0,0,.2);
	color: #fef4e9;
	border: solid 1px #da7c0c;
	background: #f78d1d;
	background: -webkit-gradient(linear, left top, left bottom, from(#faa51a), to(#f47a20));
	background: -moz-linear-gradient(top,  #faa51a,  #f47a20);

}
.page .contents td a:hover {
	text-decoration: none;
	background: #f47c20;
	background: -webkit-gradient(linear, left top, left bottom, from(#f88e11), to(#f06015));
	background: -moz-linear-gradient(top,  #f88e11,  #f06015);

}
.page .contents td a:active {
	position: relative;
	top: 1px;
	color: #fcd3a5;
	background: -webkit-gradient(linear, left top, left bottom, from(#f47a20), to(#faa51a));
	background: -moz-linear-gradient(top,  #f47a20,  #faa51a);

}'
! !

!SGLibrary methodsFor: 'pics' stamp: 'obi 6/26/2010 19:42'!
check0Gif
	^ #(71 73 70 56 57 97 16 0 22 0 230 66 0 229 229 229 233 233 233 247 247 247 231 231 231 254 254 254 129 129 129 246 246 246 234 234 234 243 243 243 145 145 145 45 45 45 240 240 240 221 221 221 178 178 178 132 132 132 253 253 253 224 224 224 179 179 179 232 232 232 185 185 185 222 222 222 241 241 241 239 239 239 220 220 220 164 164 164 210 210 210 245 245 245 158 158 158 226 226 226 217 217 217 219 219 219 156 156 156 176 176 176 127 127 127 99 99 99 173 173 173 187 187 187 215 215 215 170 170 170 209 209 209 46 46 46 130 130 130 186 186 186 230 230 230 131 131 131 211 211 211 227 227 227 166 166 166 133 133 133 47 47 47 188 188 188 248 248 248 189 189 189 151 151 151 183 183 183 168 168 168 213 213 213 98 98 98 49 49 49 50 50 50 216 216 216 218 218 218 238 238 238 223 223 223 242 242 242 255 255 255 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 66 0 44 0 0 0 0 16 0 22 0 0 7 189 128 66 130 131 132 133 134 135 136 137 138 139 140 131 65 29 33 14 14 41 5 149 14 48 44 29 65 130 2 9 56 65 4 161 161 15 65 30 9 26 130 7 5 1 8 173 64 175 64 8 170 7 130 0 9 3 62 185 186 185 3 9 0 130 28 27 30 1 196 197 7 18 60 27 28 130 16 24 45 61 208 209 208 39 24 16 130 63 35 61 63 219 220 63 16 37 38 63 130 12 54 46 43 0 232 232 3 18 12 32 12 130 23 52 22 21 175 11 244 11 64 62 36 23 130 20 19 22 2 12 204 48 32 160 160 128 5 50 40 8 26 80 195 64 144 135 16 31 106 248 48 64 144 129 23 34 116 160 80 16 67 129 199 29 57 110 24 16 244 0 72 134 9 17 82 54 88 169 34 3 144 7 141 98 202 156 121 40 16 0 59) asByteArray! !

!SGLibrary methodsFor: 'pics' stamp: 'obi 6/26/2010 19:42'!
check1Gif
	^ #(71 73 70 56 57 97 16 0 22 0 230 77 0 184 184 184 198 198 198 205 205 205 180 180 180 96 96 96 194 194 194 29 34 48 178 178 178 132 132 132 185 185 185 179 179 179 129 129 129 182 182 182 191 191 191 197 197 197 80 80 80 183 183 183 109 109 109 190 190 190 234 234 234 210 210 210 253 253 253 231 231 231 115 115 115 255 255 255 226 226 226 242 242 242 192 192 192 127 127 127 229 229 229 220 220 220 217 217 217 224 224 224 222 222 222 170 170 170 223 223 223 246 246 246 221 221 221 167 167 167 162 162 162 174 174 174 130 130 130 102 102 102 121 121 121 181 181 181 136 136 136 186 186 186 119 119 119 172 172 172 138 138 138 1 1 1 139 139 139 124 124 124 117 117 117 175 175 175 114 116 122 107 107 107 204 204 204 50 50 50 133 133 133 196 196 196 245 245 245 134 134 134 49 49 49 247 247 247 140 140 140 199 199 199 164 164 164 160 160 160 166 166 166 148 149 152 131 131 131 193 193 193 169 169 169 189 189 189 206 206 206 0 0 0 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 77 0 44 0 0 0 0 16 0 22 0 0 7 190 128 77 130 131 132 133 134 135 136 137 138 139 140 131 24 31 28 8 8 41 11 149 8 59 71 31 24 130 64 4 67 75 2 161 161 57 75 34 4 61 130 19 15 0 5 173 72 175 72 5 9 15 19 130 29 4 12 74 186 187 186 12 4 29 130 25 17 34 0 197 198 9 16 38 17 25 130 32 23 39 73 209 210 209 68 23 32 130 35 52 73 40 55 6 222 6 70 54 69 43 35 130 37 62 7 44 3 235 235 12 16 48 28 37 130 30 65 18 27 175 13 247 13 72 74 49 30 130 33 90 72 8 224 64 136 131 0 8 3 52 152 17 66 144 5 21 14 150 72 156 40 145 7 14 11 130 72 212 208 193 164 163 71 38 50 126 188 32 33 168 130 6 10 9 20 168 60 192 210 5 5 13 21 26 201 156 73 243 80 32 0 59) asByteArray! !

!SGLibrary methodsFor: 'pics' stamp: 'obi 6/26/2010 19:42'!
check2Gif
	^ #(71 73 70 56 57 97 16 0 22 0 230 94 0 189 189 189 193 193 193 205 205 205 198 198 198 184 184 184 182 182 182 96 96 96 178 178 178 132 132 132 197 197 197 169 169 169 194 194 194 179 179 179 129 129 129 221 221 221 220 220 220 190 190 190 191 191 191 246 246 246 109 109 109 229 229 229 222 222 222 126 126 128 255 255 255 234 234 234 80 80 80 242 242 242 253 253 253 224 224 224 231 231 231 127 127 127 185 185 185 217 217 217 226 226 226 210 210 210 115 115 115 192 192 192 170 170 170 223 223 223 124 124 124 136 136 136 134 134 134 57 59 63 186 186 186 31 33 38 247 247 247 130 131 132 162 162 162 183 183 183 0 1 6 0 0 2 121 122 124 160 160 160 138 138 138 133 133 133 145 146 147 97 99 102 102 102 102 117 117 117 107 107 107 139 139 139 175 175 175 164 164 164 172 172 172 145 145 147 204 204 204 50 50 50 199 199 199 90 92 94 245 245 245 1 1 1 130 130 130 126 127 128 181 181 181 92 93 96 167 167 167 180 180 180 140 140 140 174 174 174 121 121 121 160 160 161 131 131 131 187 187 187 123 124 126 196 196 196 166 166 166 119 119 119 150 150 151 4 7 12 2 5 11 111 112 114 49 49 49 206 206 206 0 0 0 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 94 0 44 0 0 0 0 16 0 22 0 0 7 203 128 94 130 131 132 133 134 135 136 137 138 139 140 131 23 32 30 8 8 71 13 149 8 54 81 32 23 130 45 6 62 92 2 161 161 65 92 37 6 69 130 24 25 4 11 173 1 175 83 5 31 25 24 130 20 6 5 0 186 186 74 93 82 5 6 20 130 33 19 37 4 199 4 51 93 93 80 75 19 33 130 28 35 47 10 90 46 87 49 88 72 10 52 35 28 130 38 39 10 68 93 44 42 89 55 78 61 85 79 38 130 14 41 7 73 22 50 93 22 76 5 48 63 30 14 130 15 77 16 72 4 0 130 67 96 132 0 0 106 60 16 84 1 5 132 1 9 134 36 24 64 113 64 4 30 21 4 117 200 145 128 139 199 143 30 169 236 232 32 72 130 14 33 203 82 46 51 178 197 138 4 65 27 52 136 248 192 160 230 129 155 43 68 104 216 208 168 167 207 159 135 2 1 0 59) asByteArray! !

!SGLibrary methodsFor: 'pics' stamp: 'obi 6/26/2010 19:43'!
collapsedGif
	^ #(71 73 70 56 57 97 16 0 13 0 213 47 0 56 91 150 64 104 165 190 190 190 48 78 135 71 117 179 56 92 150 48 79 135 71 116 179 78 127 192 196 196 196 41 66 121 41 67 121 63 104 165 233 233 233 239 239 239 56 85 138 221 227 235 97 112 147 161 165 175 203 203 203 155 187 224 193 193 193 181 182 186 121 152 195 226 226 226 210 210 210 55 72 116 233 237 241 55 91 149 139 145 161 128 141 166 73 111 168 73 103 155 73 89 129 150 171 201 219 219 219 105 145 197 34 56 108 90 141 202 64 105 165 78 128 192 202 214 230 180 201 226 84 137 202 232 234 238 186 192 203 34 55 108 243 243 243 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 47 0 44 0 0 0 0 16 0 13 0 0 6 82 192 151 112 72 44 22 41 27 163 242 181 50 169 150 69 20 2 65 74 65 133 132 236 225 112 129 64 25 140 192 41 16 248 136 88 74 0 160 176 6 112 64 45 135 113 96 24 208 31 30 65 162 97 92 40 252 17 22 21 35 75 46 37 33 18 2 25 114 75 26 29 2 19 124 87 47 9 24 147 151 66 65 0 59) asByteArray! !

!SGLibrary methodsFor: 'pics' stamp: 'obi 6/26/2010 19:43'!
expandedGif
	^ #(71 73 70 56 57 97 16 0 13 0 213 48 0 216 216 216 190 190 190 89 89 89 110 110 110 239 239 239 138 138 138 108 108 108 125 125 125 28 28 28 69 69 69 68 68 68 236 236 236 196 196 196 48 48 48 213 213 213 114 114 114 233 233 233 199 199 199 177 177 177 193 193 193 226 226 226 219 219 219 170 170 170 230 230 230 47 47 47 191 191 191 148 148 148 90 89 89 228 228 228 181 181 181 138 138 136 184 184 184 34 35 35 175 175 175 119 119 119 56 56 56 131 131 131 110 108 108 203 203 203 130 129 129 121 121 121 105 105 105 124 124 124 223 223 223 90 90 90 136 136 136 127 127 127 217 217 217 243 243 243 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 48 0 44 0 0 0 0 16 0 13 0 0 6 90 64 152 112 72 44 14 87 175 23 64 185 76 26 63 158 150 180 208 162 106 46 197 5 201 117 112 121 187 22 134 49 99 40 13 12 131 193 41 64 49 194 30 130 141 128 37 144 152 220 176 72 66 177 71 5 22 120 48 41 13 24 35 29 14 129 48 0 8 8 34 19 4 137 48 42 32 1 21 145 48 28 33 98 151 48 4 16 156 137 65 0 59) asByteArray! !

!SGLibrary methodsFor: 'other' stamp: 'obi 11/21/2010 15:24'!
magritteCss
	^'ul.errors {color:#f44;padding-left:16px}
	ul.errors li {margin-left:8px;padding:2px;list-style:disc}
	form table {margin-top:4px}
	textarea {width:400px}
	.modelTitle {font-size:120%;padding:6px;color:#666}
	fieldset select {}
	fieldset span.required {color:red;font-size:120%;}
	fieldset span.required:after
		{
		content: " *";
		}
	fieldset {  
		-moz-border-radius: 5px;
		border-radius: 5px;
		float: left;     
		clear: both;     
		width: 99%;     
		margin: 0 0.5em 0.5em 0.5em;     
		padding: 0;     
		border: 1px solid #BFBAB0;     
	background-color: #F2EFE9;
	background: -webkit-gradient(
    linear,
    left bottom,
    left top,
    color-stop(0, rgb(212,216,255)),
    color-stop(0.8, rgb(255,255,255))
);
background: -moz-linear-gradient(
    center bottom,
    rgb(186,186,186) 37%,
    rgb(237,237,237) 80%
)
		}  
legend {   
margin-left: 1em;  
padding:0;
color: #000;
background:#fff;
font-weight: bold;  
}  
fieldset ol {   
padding: 0 1em 0 1em;   
list-style: none;  
}  
fieldset li {  
float: left;    
clear: left;    
width: 100%;  
margin: 0 0 0.6em 0;    
padding: 0; 
}  
fieldset.submit {   
float: none;     
width: auto;     
border-style: none;     
padding-left: 12em;     
background-color: transparent;   
}
label {    
float: left;    
width: 10em;    
margin-top:0.5em;
margin-right: 1em;   
}'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 11/07/2008 13:52'!
notUsedCss
	^'	.page .contents td a {-moz-border-radius: 5px;-webkit-border-radius:5px;border-radius:5px;text-decoration:none;background:#888;border:1px solid #666;padding:0px 4px 0px 4px;color:white;white-space:nowrap}
	.page .contents td a:hover {background:#aaa}'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 11/21/2010 15:33'!
selectorsToInclude
	^ #(#adminCss #magritteCss #buttonCss)
! !

WAFileLibrary subclass: #SGProjectLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGProjectLibrary methodsFor: 'other' stamp: 'obi 12/28/2010 18:29'!
defaultCss
	^'
	html {height:100%; overflow:hidden}
	body {margin: 4px;padding: 0;border: 0px;overflow:hidden;height:100%;}
	body, div, tr, td, th, form input, form submit {font-family: verdana, Arial, Helvetica, sans-serif;font-size: 11px;}
	table, tr, td, th, form {margin: 0px;padding: 0px;border: 0px;}
	th {text-align: left;}
	td {padding:1px 2px} 
	a, tr th a, tr th a:hover {background:none;color:#5588ff;text-decoration: none;border:0}
	.page .contents td {padding:2px 1px}
	td a, a.action {-moz-border-radius: 5px;-webkit-border-radius:5px;border-radius:5px;text-decoration:none;background:#888;border:1px solid #666;padding:0px 4px 0px 4px;color:white;white-space:nowrap}
	td a:hover, a.action:hover {background:#aaa}
	h1,h2,h3 {margin-top: 0px}
	h1 {margin-bottom: 2px;font-size: 24px;}
	h2 {margin-bottom: 1px;font-size: 15px;}
	h3 {margin-bottom: 1px;font-size: 13px;}
	div#lightbox {padding:6px;border:1px solid blue;background:#e0e0e0;-moz-border-radius: 10px;-webkit-border-radius:10px;border-radius:10px;text-decoration:none}
	.rounded {-moz-border-radius: 10px;-webkit-border-radius:10px;border-radius:10px}
	body div#overlay {z-index: 9998; background-color: #369; filter: alpha(opacity=30); -moz-opacity: 0.3; 	opacity: 0.3}
	.list th {font-size:150%}
	.list th a {text-decoration:underline}
	div.login {margin-top:60px; padding:10px;background:#e0e0e0; border: 1px solid #ccc; width:400px }'
! !

!SGProjectLibrary methodsFor: 'other' stamp: 'obi 12/28/2010 18:30'!
magritteCss
	^'ul.errors {color:#f44;padding-left:16px}
	ul.errors li {margin-left:8px;padding:2px;list-style:disc}
	.even {background-color: #E1E1E9}
	form table {margin-top:4px}
	textarea {width:400px}
	.modelTitle {font-size:120%;padding:6px;color:#666}
	fieldset select {}
	fieldset span.required {color:red;font-size:120%;}
	fieldset span.required:after
		{
		content: " *";
		}
	fieldset {  
		-moz-border-radius: 5px;
		border-radius: 5px;
		float: left;     
		clear: both;     
		width: 99%;     
		margin: 0 0.5em 0.5em 0.5em;     
		padding: 0;     
		border: 1px solid #BFBAB0;     
	background-color: #F2EFE9;
	background: -webkit-gradient(
    linear,
    left bottom,
    left top,
    color-stop(0, rgb(212,216,255)),
    color-stop(0.8, rgb(255,255,255))
);
background: -moz-linear-gradient(
    center bottom,
    rgb(186,186,186) 37%,
    rgb(237,237,237) 80%
)
		}  
legend {   
margin-left: 1em;  
padding:0;
color: #000;
background:#fff;
font-weight: bold;  
}  
fieldset ol {   
padding: 0 1em 0 1em;   
list-style: none;  
}  
fieldset li {  
float: left;    
clear: left;    
width: 100%;  
margin: 0 0 0.6em 0;    
padding: 0; 
}  
fieldset.submit {   
float: none;     
width: auto;     
border-style: none;     
padding-left: 12em;     
background-color: transparent;   
}
label {    
float: left;    
width: 10em;    
margin-top:0.5em;
margin-right: 1em;   
}'
! !

!SGProjectLibrary methodsFor: 'other' stamp: 'obi 11/04/2008 15:03'!
selectorsToInclude
	^ #(#defaultCss #magritteCss)
! !

!MADescription methodsFor: '*seaside-scaffolding-method-creation' stamp: 'obi 05/05/2009 12:59'!
accessingMethods
	^#()! !

!MADescription methodsFor: '*seaside-scaffolding-method-creation' stamp: 'obi 05/05/2009 12:59'!
updatingMethods
	^#()! !

MAComponentRenderer subclass: #SGComponentRenderer
	instanceVariableNames: 'groupElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Renderer'!

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/21/2010 15:09'!
closeContainer
	"html fieldSet class: 'submit'"! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/20/2010 16:16'!
closeGroup
	group isNil
		ifFalse:  [
			html html: '</ol>'.
			html html: '</fieldset>' ]
! !

!SGComponentRenderer methodsFor: 'private' stamp: 'obi 11/20/2010 16:22'!
defaultGroup
	^'Edit'! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/21/2010 12:52'!
renderContainer: aDescription
	html div
		class: 'modelTitle';
		with: component model displayString.
	super renderContainer: aDescription.
	self closeGroup.
	self closeContainer! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/20/2010 19:35'!
renderControl: aDescription
	html span
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/20/2010 16:22'!
renderElement: aDescription
	| descGroup |
	descGroup := aDescription group.
	descGroup isNil ifTrue: [descGroup := self defaultGroup].
	(descGroup ~= group )
		ifTrue: [ self renderGroup: aDescription ].
	html listItem: [
		self renderLabel: aDescription.
		self renderControl: aDescription].

	! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/20/2010 16:22'!
renderGroup: aDescription
	self closeGroup.
	super renderGroup: aDescription.
	group isNil ifTrue: [ group := self defaultGroup ].
	html html: '<fieldset>'.
	html legend: group.
	html html: '<ol>'! !

!SGComponentRenderer methodsFor: 'rendering' stamp: 'obi 11/21/2010 10:53'!
renderLabel: aDescription
	| label aComponent |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label.
	(aComponent := self childAt: aDescription) hasLabelId
		ifTrue: [ label for: aComponent labelId ].
	label title: aDescription comment.	
	label with: [ html render: aDescription label ]! !

WADecoration subclass: #SGDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

SGDecoration subclass: #SGTitleDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGTitleDecoration class methodsFor: 'instance creation' stamp: 'obi 11/05/2008 16:20'!
with: aTitle
	^self new title: aTitle; yourself! !

!SGTitleDecoration methodsFor: 'rendering' stamp: 'obi 11/05/2008 16:14'!
renderContentOn: html
	self renderTitleOn: html.
	self renderOwnerOn: html! !

!SGTitleDecoration methodsFor: 'rendering' stamp: 'obi 11/05/2008 16:28'!
renderTitleOn: html
	html table: [
			html tableRow: [
				html tableData: [
					html anchor
						class: 'back';
						callback: [self component answer];
						with: '<'].
				html tableData: [html heading: title.]]]
			

	! !

!SGTitleDecoration methodsFor: 'accessing' stamp: 'obi 11/05/2008 16:13'!
title
	^title! !

!SGTitleDecoration methodsFor: 'accessing' stamp: 'obi 11/05/2008 16:13'!
title: aString
	title := aString! !

!MAContainer methodsFor: '*seaside-scaffolding-query' stamp: 'obi 05/12/2009 12:37'!
fieldDescriptions
	 ^self children select: [:desc | desc kind ~~ Collection]
! !

!MAContainer methodsFor: '*seaside-scaffolding-query' stamp: 'obi 05/12/2009 12:37'!
noneRelationDescriptions
	 ^self fieldDescriptions
! !

!MAContainer methodsFor: '*seaside-scaffolding-query' stamp: 'obi 05/12/2009 12:36'!
relationDescriptions
	 ^self children select: [:desc | desc kind ~~ Collection]
! !

MAOneToManyComponent subclass: #SGTwowayRelationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Component'!

!SGTwowayRelationComponent class methodsFor: 'testing' stamp: 'obi 05/12/2009 10:59'!
isAbstract
	^ false! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/16/2009 11:21'!
add
	| newModel result |
	newModel := self selected new.
	result := self root call: newModel open.
	result isNil
		ifFalse: [self add: newModel; refresh]
		ifTrue: [newModel discard]! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/16/2009 10:55'!
add: anObject
	self description accessor add: anObject to: self model.
	"self refresh"! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:41'!
buildCommands
	commands := MACommandColumn new setReport: self report.
	self description isDefinitive ifFalse: [
		commands
			addCommandOn: self selector: #edit: text: 'edit';
			addCommandOn: self selector: #remove: text: 'remove' ].
	^ commands! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:37'!
buildReport
	| newReport |
	newReport := (MAReport rows: self value)
					sortEnabled: self description isOrdered not.
	self reference noneRelationDescriptions do: [:desc | newReport addColumnDescription: desc ].
	^newReport! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:49'!
model
	^self memento model! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/12/2009 12:49'!
remove: anObject
	self description accessor remove: anObject from: self model.
	self refresh! !

!SGTwowayRelationComponent methodsFor: 'rendering' stamp: 'obi 05/16/2009 11:22'!
renderEditorOn: html
	 self renderSelectListOn: html.
	self renderViewerOn: html.! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 11/21/2010 13:13'!
renderSelectButtonOn: html
	super renderSelectButtonOn: html.
	html submitButton on: #select of: self! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 11/21/2010 19:47'!
select
	| selectedInstances result listChooser |
	selectedInstances := self selected instances copy.
	selectedInstances removeAllFoundIn: self value.
	listChooser := SGMultiListChooser on: (selectedInstances asSortedCollection: self selected defaultSortBlock).
	listChooser title: 'Select instance of ', self selected displayStringClass.
	result := self root lightbox: listChooser.
	result isNil
		ifFalse: [result do: [:each | self add: each].
				self refresh]
	! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 11/21/2010 14:27'!
validatedFormOn: result forOperation: aString
	^ result asComponent
		addValidatedForm;
		yourself! !

MACommandColumn subclass: #SGCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCommandColumn methodsFor: 'rendering' stamp: 'obi 11/01/2008 05:10'!
renderCellFormContent: anObject on: html
	self commands
		do: [ :each |
			html submitButton
				callback: [ each key value: self report value: anObject];
				text: each value ]
		separatedBy: [ html space ]! !

!SGCommandColumn methodsFor: 'rendering' stamp: 'obi 11/01/2008 05:10'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			html anchor
				callback: [ each key value: self report value: anObject ];
				with: each value ]
		separatedBy: [ html space ]! !

MARelationDescription subclass: #SGTwowayRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 05/12/2009 10:58'!
defaultComponentClasses
	^ Array with: SGTwowayRelationComponent! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/21/2009 12:58'!
defaultDefault
	^OrderedCollection new
"	^SGTwowayRelation new"! !

!SGTwowayRelationDescription class methodsFor: 'accessing-description' stamp: 'obi 04/19/2009 10:57'!
descriptionClasses
	^ MAMultipleOptionDescription new
		accessor: #classes;
		label: 'Classes';
		priority: 400;
		options: [ SGModel allSubclasses ] asDynamicObject;
		reference: MAClassDescription new;
		yourself! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/19/2009 11:04'!
isAbstract
	^ false! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/19/2009 11:03'!
label
	^ 'Twoway Relation'! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:40'!
isDefinitive
	^false! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:37'!
isOrdered
	^true! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:37'!
isSorted
	^false! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 05/12/2009 12:32'!
kind
	^ Collection! !

!SGTwowayRelationDescription methodsFor: 'accessors' stamp: 'obi 04/22/2009 13:40'!
selectorAccessor: aSelector
	"Use SGTwowayRelationAccessor instead of default one"

	self accessor: (SGTwowayRelationAccessor selector: aSelector)! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/22/2009 13:35'!
targetSelector
	^self accessor targetSelector! !

!SGTwowayRelationDescription methodsFor: 'updating' stamp: 'obi 04/21/2009 13:20'!
targetSelector: aSymbol
	"the accessor must be set before"
	self accessor targetSelector: aSymbol! !

!SGTwowayRelationDescription methodsFor: 'method-creation' stamp: 'obi 05/05/2009 13:00'!
updatingMethods
	| newLine sourceString sourceString2 var |
	newLine := Character lf asString.
	var := self accessor readSelector asString.
	sourceString := String new.
	sourceString add: var , 'Add: aModel', newLine , newLine.
	sourceString add: '	(self accessorFor: #' , var , ') write: aModel to: self'.
	sourceString2 := String new.
	sourceString2 add: var , 'Remove: aModel', newLine , newLine.
	sourceString2 add: '	(self accessorFor: #' , var , ') remove: aModel from: self'.
	^Array with: sourceString with: sourceString2! !

TestCase subclass: #SGTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Test'!

!SGTestCase methodsFor: 'private' stamp: 'obi 6/13/2010 19:15'!
classNamed: aName
	^SGSystem classNamed: aName! !

!SGTestCase methodsFor: 'private' stamp: 'obi 11/07/2008 06:49'!
createTestClass
	| aClass |
	aClass := SGModel subclass: #SGTestA instVarNames: #(name description counter).
	aClass descriptionAt: 3 put: (aClass integerDescriptionOn: #counter).
	^aClass! !

!SGTestCase methodsFor: 'private' stamp: 'obi 11/07/2008 06:07'!
executeWithTestClass: aBlock
	[aBlock value: self createTestClass] ensure: [self removeTestClass]! !

!SGTestCase methodsFor: 'private' stamp: 'obi 10/28/2008 13:30'!
removeClass: aClass
	aClass isNil ifFalse: [
		aClass safelyDo: [:i | i discard].
		self assert: (SGSystem removeClassNamed: aClass name)].! !

!SGTestCase methodsFor: 'private' stamp: 'obi 10/28/2008 13:33'!
removeTestClass
	self removeClass: self testClass! !

!SGTestCase methodsFor: 'test-components' stamp: 'obi 10/28/2008 13:34'!
testAsComponent
	| newObject |
	self createTestClass.
	newObject := self testClass new.
	newObject asComponent.
	self removeTestClass! !

!SGTestCase methodsFor: 'private' stamp: 'obi 11/03/2008 13:54'!
testClass
	^self classNamed: #SGTestA! !

!SGTestCase methodsFor: 'test-descriptions' stamp: 'obi 10/28/2008 12:26'!
testDescription
	| aContainer |
	aContainer := SGModel description.
	self assert: (aContainer isKindOf: MAContainer).
	self assert: aContainer children isEmpty! !

SGTestCase subclass: #SGTestInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Test'!

!SGTestInstance methodsFor: 'testing' stamp: 'obi 11/07/2008 06:52'!
testInstanceAttributeChange
	self executeWithTestClass:
		[:aClass | | newObject |
		newObject := aClass new.
		newObject name: 'Test'.
		newObject description: 'Description'.
		newObject counter: 10.
		self assert: (newObject name = 'Test').
		self assert: (newObject description = 'Description').
		self assert: (newObject counter = 10)]! !

!SGTestInstance methodsFor: 'testing' stamp: 'obi 11/07/2008 06:50'!
testInstanceAttributeInitialize
	self executeWithTestClass:
		[:aClass | | newObject |
		newObject := aClass new.
		self assert: (newObject name isNil).
		self assert: (newObject description isNil).
		self assert: (newObject counter = 0)]! !

!SGTestInstance methodsFor: 'testing' stamp: 'obi 11/20/2010 14:27'!
testInstanceCreating
	| anObject oldSize newSize|
	oldSize := SGModel instances size.
	anObject := SGModel new.
	
	self assert: (anObject isKindOf: SGModel).
	self assert: oldSize + 1 == SGModel instances size.
	anObject discard.
	self assert: oldSize == SGModel instances size.! !

!SGTestInstance methodsFor: 'testing' stamp: 'obi 05/05/2009 13:36'!
testTwowayRelation
	| aUser aUser2 aGroup |
	aUser := SGUser new.
	aUser loginName: 'TestUser_1'.
	aUser2 := SGUser new.
	aUser2 loginName: 'TestUser_2'.
	aGroup := SGGroup new.
	aGroup name: 'TestGroup'.
	aUser groupsAdd: aGroup.
	aGroup usersAdd: aUser2.
	self assert: aGroup users size = 2.
	self assert: aUser groups size = 1.
	self assert: aUser2 groups size = 1.
	aUser discard.
	self assert: aGroup users size = 1.
	aUser2 discard.
	self assert: aGroup users size = 0.
	aGroup discard! !

SGTestCase subclass: #SGTestMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Test'!

!SGTestMigration methodsFor: 'testing' stamp: 'obi 6/13/2010 20:16'!
testClassCreation
	| testClassName newClass newObject |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	self assert: newClass notNil.
	newObject := newClass new.
	newObject name: 'Test'; description: 'Description'.
	self assert: newObject name = 'Test'.
	self assert: newClass description notNil.
	self assert: (newClass attributeDescriptions size == 2).
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGSystem classNamed: testClassName) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.! !

!SGTestMigration methodsFor: 'testing' stamp: 'obi 6/13/2010 20:18'!
testClassRedefine
	| testClassName newClass newObject newObject2 |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	newClass attributeContainer.
	newObject := newClass new.
	newClass := SGModel subclass: testClassName instVarNames: #(name description label).
	self assert: (newClass attributeDescriptions size == 3).
	newObject2 := newClass new.
	newObject name: 'Test'; description: 'Description'; label: 'Label'.
	newObject2 name: 'Test2'; description: 'Description2'; label: 'Label2'.
	self assert: newClass meta keys notEmpty.
	self assert: newObject class = newObject2 class.
	self assert: newObject name = 'Test'.
	self assert: newObject2 name = 'Test2'.
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGSystem classNamed: testClassName) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.! !

!SGTestMigration methodsFor: 'testing' stamp: 'obi 6/13/2010 20:18'!
testClassRedefine2
	| testClassName newClass newObject newObject2 |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description label).
	newClass attributeContainer.
	newObject := newClass new.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	self assert: (newClass attributeDescriptions size == 2).
	newObject2 := newClass new.
	newObject name: 'Test'; description: 'Description'.
	newObject2 name: 'Test2'; description: 'Description2'.
	self assert: newClass meta keys notEmpty.
	self assert: newObject class = newObject2 class.
	self assert: newObject name = 'Test'.
	self assert: newObject2 name = 'Test2'.
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGSystem classNamed: testClassName) isNil.
	self deny: (SGSystem hasInstancesOf: testClassName).! !

!SGTestMigration methodsFor: 'testing' stamp: 'obi 6/13/2010 20:17'!
testSuperclassRedefine
	| testClassName testClassName2 newClass newClass2 newObject newObject2 |
	testClassName := #SGTestA.
	testClassName2 := #SGTestA1.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	newObject := newClass new.
	newObject name: 'Test A'.
	newClass2 := newClass subclass: testClassName2 instVarNames: #(test1 test2).
	newObject := newClass2 new.
	newObject name: 'Test A1'.
	newClass := SGModel subclass: testClassName instVarNames: #(name).
	
	"reassign class"
	newClass2 := SGSystem classNamed: testClassName2.
	
	self assert: newClass2 allInstVarNames size == 3.
	newClass safelyDo: [:i | i discard].
	newClass2 safelyDo: [:i | i discard]. 
	self assert: (SGSystem removeClassNamed: testClassName2).
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGSystem classNamed: testClassName) isNil.
	self assert: (SGSystem classNamed: testClassName2) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.
	self assert: (SGSystem hasInstancesOf: testClassName2) not.! !

Object subclass: #SGModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

SGModel class
	instanceVariableNames: 'Meta'!

!SGModel commentStamp: '<historical>' prior: 0!
Root class for all my model classes.
!

SGModel class
	instanceVariableNames: 'Meta'!

SGModel subclass: #SGClassModel
	instanceVariableNames: 'name superClassName attributes comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGClassModel class methodsFor: 'testing' stamp: 'obi 11/22/2010 22:08'!
canCreateSubclass
	^false! !

!SGClassModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:36'!
descriptionAttributes
	^self memoDescriptionOn: #attributes! !

!SGClassModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:33'!
descriptionComment
	^self memoDescriptionOn: #comment! !

!SGClassModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:34'!
descriptionName
	^self stringDescriptionOn: #name! !

!SGClassModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:36'!
descriptionSuperClassName
	^self stringDescriptionOn: #superClassName! !

!SGClassModel class methodsFor: 'testing' stamp: 'obi 11/22/2010 22:07'!
isBasic
	^true! !

!SGClassModel methodsFor: 'testing' stamp: 'obi 11/20/2010 14:30'!
isPersistent
	^false! !

SGModel subclass: #SGGroup
	instanceVariableNames: 'name label defaultMandator allowedMandators accessRights users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGGroup commentStamp: '<historical>' prior: 0!
group!

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 11/21/2010 10:55'!
descriptionAccessRights
	^MAStringDescription new
		selectorAccessor: 'accessRights';
		cssClass: 'string';
		priority: 1;
		label: 'Access Rights';
		yourself! !

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 11/21/2010 10:55'!
descriptionAllowedMandators
	^MAStringDescription new
		selectorAccessor: 'allowedMandators';
		cssClass: 'string';
		priority: 1;
		label: 'Allowed Mandators';
		yourself! !

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 11/21/2010 10:55'!
descriptionDefaultMandator
	^MAStringDescription new
		selectorAccessor: 'defaultMandator';
		cssClass: 'string';
		priority: 1;
		label: 'Default Mandator';
		yourself! !

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 05/05/2009 13:14'!
descriptionLabel
	^MAStringDescription new
		selectorAccessor: 'label';
		cssClass: 'string';
		priority: 1;
		label: 'Label';
		yourself! !

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 05/05/2009 13:14'!
descriptionName
	^MAStringDescription new
		selectorAccessor: 'name';
		cssClass: 'string';
		priority: 1;
		label: 'Name';
		yourself! !

!SGGroup class methodsFor: 'accessing-description' stamp: 'obi 11/21/2010 10:56'!
descriptionUsers
	^SGTwowayRelationDescription new
		selectorAccessor: 'users';
		targetSelector: #groups;
		cssClass: 'object';
		priority: 100;
		label: 'Users';
		group: 'Relations';
		visible: true;
		classes: (OrderedCollection with: SGUser);
		yourself! !

!SGGroup class methodsFor: 'testing' stamp: 'obi 11/01/2008 11:07'!
isBasic
	^name == #SGGroup! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
accessRights

   "Return the value of the instance variable 'accessRights'."
   ^accessRights
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
accessRights: newValue

   "Modify the value of the instance variable 'accessRights'."
   accessRights := newValue
! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
allowedMandators

   "Return the value of the instance variable 'allowedMandators'."
   ^allowedMandators
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
allowedMandators: newValue

   "Modify the value of the instance variable 'allowedMandators'."
   allowedMandators := newValue
! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
defaultMandator

   "Return the value of the instance variable 'defaultMandator'."
   ^defaultMandator
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
defaultMandator: newValue

   "Modify the value of the instance variable 'defaultMandator'."
   defaultMandator := newValue
! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
label

   "Return the value of the instance variable 'label'."
   ^label
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue
! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
name

   "Return the value of the instance variable 'name'."
   ^name
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue
! !

!SGGroup methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:44'!
users

   "Return the value of the instance variable 'users'."
   ^users
! !

!SGGroup methodsFor: 'Updating' stamp: 'obi 10/31/2008 11:44'!
users: newValue

   "Modify the value of the instance variable 'users'."
   users := newValue
! !

!SGGroup methodsFor: 'updating' stamp: 'obi 05/05/2009 13:14'!
usersAdd: aModel

	(self accessorFor: #users) write: aModel to: self! !

!SGGroup methodsFor: 'updating' stamp: 'obi 05/05/2009 13:14'!
usersRemove: aModel

	(self accessorFor: #users) remove: aModel from: self! !

SGModel subclass: #SGMandator
	instanceVariableNames: 'name info classes properties accessRights users'
	classVariableNames: 'List'
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGMandator class methodsFor: 'updating' stamp: 'obi 10/26/2008 00:16'!
add: aMandator
	self list add: aMandator! !

!SGMandator class methodsFor: 'public' stamp: 'obi 10/26/2008 11:10'!
allDo: aBlock
	self list do: aBlock! !

!SGMandator class methodsFor: 'testing' stamp: 'obi 11/02/2008 09:40'!
canCreateSubclass
	^false! !

!SGMandator class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:17'!
canEdit
	^false! !

!SGMandator class methodsFor: 'accessing' stamp: 'dkh 04/08/2009 11:05'!
default
	| aList newMandator |
	aList := self list.
	aList isEmpty
		ifTrue: [newMandator := self new.
				newMandator name: 'Default'.
				newMandator description: 'Default mandator'.
				self add: newMandator].
	^self list anyOne! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 6/14/2010 22:26'!
descriptionAccessRights
	^ MAToManyRelationDescription new
		classes: (Array new);
		accessor: #accessRights;
		label: 'Access Rights';
		default: OrderedCollection new;
		priority: 100;
		visible: false;
		beDefinitive;
		beOrdered;
		yourself! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 10/31/2008 11:30'!
descriptionClasses
	| desc |
	desc := self stringDescriptionOn: #classes.
	desc visible: false.
	^desc! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 6/15/2010 23:09'!
descriptionInfo
	| desc |
	desc := self stringDescriptionOn: #info.
	^desc! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 10/31/2008 11:35'!
descriptionName
	| desc |
	desc := self stringDescriptionOn: #name.
	desc required: true.
	^desc! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 10/31/2008 11:29'!
descriptionProperties
	| desc |
	desc := self stringDescriptionOn: #properties.
	desc visible: false.
	^desc! !

!SGMandator class methodsFor: 'descriptions' stamp: 'obi 6/14/2010 22:26'!
descriptionUsers
	^ MAToManyRelationDescription new
		classes: (Array with: SGUser);
		accessor: #users;
		default: OrderedCollection new;
		label: 'Users';
		priority: 100;
		beDefinitive;
		beOrdered;
		yourself! !

!SGMandator class methodsFor: 'accessing' stamp: 'obi 11/21/2010 11:07'!
instances
	^self list! !

!SGMandator class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:18'!
isBasic
	^true! !

!SGMandator class methodsFor: 'accessing' stamp: 'obi 04/07/2009 13:29'!
list
	List isNil ifTrue: [List := IdentitySet new].
	^List! !

!SGMandator class methodsFor: 'updating' stamp: 'obi 10/26/2008 00:34'!
remove: aMandator
	self list remove: aMandator ifAbsent: []! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/26/2008 00:29'!
accessRights

   "Return the value of the instance variable 'accessRights'."
   ^accessRights
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/26/2008 00:29'!
accessRights: newValue

   "Modify the value of the instance variable 'accessRights'."
   accessRights := newValue
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:58'!
add: anObject 
	^self add: anObject to: anObject class
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:46'!
add: anObject to: aClass
	(self instancesAt: aClass name) add: anObject.
	^anObject! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:47'!
addAll: aColl to: aClass
	(self instancesAt: aClass name) addAll: aColl.
	^aColl! !

!SGMandator methodsFor: 'public' stamp: 'obi 10/26/2008 10:27'!
beCurrent
	SGSystem currentMandator: self! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/26/2008 00:29'!
classes

   "Return the value of the instance variable 'classes'."
   ^classes
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/26/2008 00:29'!
classes: newValue

   "Modify the value of the instance variable 'classes'."
   classes := newValue
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 10:23'!
classesDo: aBlock

	classes keys do: aBlock
! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/26/2008 00:29'!
description

   "Return the value of the instance variable 'description'."
   ^description
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/26/2008 00:29'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 11:09'!
hasInstancesOf: className
	^(classes at: className ifAbsent: [#()]) notEmpty! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 6/15/2010 23:08'!
info

   "Return the value of the instance variable 'info'."
   ^info
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 6/15/2010 23:08'!
info: newValue

   "Modify the value of the instance variable 'info'."
   info := newValue
! !

!SGMandator methodsFor: 'initialize' stamp: 'obi 6/15/2010 23:08'!
initialize
	super initialize.
	name := 'No name'.
	info := ''.
	classes := Dictionary new.
	properties := Dictionary new.! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:47'!
instancesAt: className
	^classes at: className ifAbsent: [classes at: className put: self newInstanceCollection]! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 10:23'!
instancesDo: aBlock

	classes values do: aBlock
! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/26/2008 00:29'!
name

   "Return the value of the instance variable 'name'."
   ^name
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/26/2008 00:29'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue
! !

!SGMandator methodsFor: 'private' stamp: 'obi 11/22/2010 21:50'!
newInstanceCollection
	^SGSystem instanceCollectionClass new! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/26/2008 00:29'!
properties

   "Return the value of the instance variable 'properties'."
   ^properties
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/26/2008 00:29'!
properties: newValue

   "Modify the value of the instance variable 'properties'."
   properties := newValue
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:57'!
remove: anObject
	^self remove: anObject from: anObject class
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 00:58'!
remove: anObject from: aClass
	^(self instancesAt: aClass name) remove: anObject
! !

!SGMandator methodsFor: 'instance-accessing' stamp: 'obi 10/26/2008 11:14'!
removeClassNamed: className
	^classes removeKey: className ifAbsent: []! !

!SGMandator methodsFor: 'Accessing' stamp: 'obi 10/31/2008 09:44'!
users

   "Return the value of the instance variable 'users'."
   ^users
! !

!SGMandator methodsFor: 'Updating' stamp: 'obi 10/31/2008 09:44'!
users: newValue

   "Modify the value of the instance variable 'users'."
   users := newValue
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/01/2008 10:33'!
<= aClass
	^name <= aClass name! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/05/2009 12:54'!
accessorFor: anAttribute
	self allAttributeDescriptions do: [:desc | | acc | (acc := desc accessor) readSelector == anAttribute ifTrue: [^acc]].
	^nil! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/16/2009 10:51'!
accessorForAttribute: anAttribute
	self attributeContainer children do: [:desc | | accessor | accessor := desc accessor. accessor readSelector == anAttribute ifTrue: [^accessor]].
	^nil! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 6/26/2010 20:08'!
activeSubclasses
	^self subclasses select: [:each | (SGSystem classNamed: each name) notNil ]! !

!SGModel class methodsFor: 'adding-removing' stamp: 'obi 12/20/2008 12:35'!
add: anObject
	^self currentMandator add: anObject! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 12/17/2008 11:02'!
addClassesAccessorFor: aDescription on: sourceString
	| theClasses |
	theClasses := aDescription classes.
	theClasses isEmpty ifFalse: [
			| str |
			str := String new.
			str add: '		classes: (Array new add: '.
			theClasses do: [:cl | str add: cl name asString] separatedBy: [str add: '; add: '].
			str add: '; yourself);'.
			sourceString add: str]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:56'!
addDescription: anAttributeDescription
	^self attributeContainer add: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 6/13/2010 19:40'!
allAttributeDescriptions
	| allDescriptions |

	allDescriptions := OrderedCollection new.
	self mySuperClasses reverseDo: [:cl |
		allDescriptions addAll: cl attributeContainer children].
	allDescriptions addAll: self attributeContainer children.
	^allDescriptions! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 6/15/2010 22:40'!
allClasses
	^self withAllSubclasses asSortedCollection! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 6/15/2010 22:41'!
allUserClasses
	^(self withAllSubclasses select: [:cl | cl isBasic not]) asSortedCollection! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/08/2008 05:28'!
allVisibleAttributeDescriptions
	^self allAttributeDescriptions select: [:each | each isVisible]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/08/2008 05:52'!
allVisibleReadAccessors
	^self allVisibleAttributeDescriptions collect: [:desc | desc accessor readSelector]! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 04/21/2009 11:22'!
any
	self do: [:each | ^each].
	^nil! !

!SGModel class methodsFor: 'private' stamp: 'obi 6/13/2010 17:50'!
asLabel: aSelector
	^aSelector asString capitalized
	
	! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/28/2008 12:42'!
attributeContainer
	^self metaAtKey: #attributeContainer ifAbsent: [self metaAtKey: #attributeContainer put: self descriptionContainer].! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/28/2008 12:55'!
attributeDescriptions
	| theDescriptions |
	theDescriptions := self attributeContainer children.
	theDescriptions isEmpty ifTrue: [theDescriptions := self createDefaultDescriptions].
	^theDescriptions! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 6/14/2010 22:52'!
attributesAsString
	| result |
	result := WriteStream on: String new.
	self instVarNames do: [:aSymbol | 
			result nextPutAll: aSymbol asString] separatedBy: [result nextPut: $;].
	^result contents! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 6/16/2010 21:42'!
cacheDescriptionMethods
	"use this to cache manually defined or changed descriptions methods"
	| currentDescriptions theInstVars |
	currentDescriptions := self attributeDescriptions.
	theInstVars := self instVarNames collect: [:each | each asSymbol ].
	theInstVars do: [:aSymbol | | currentDescription |
		currentDescription := currentDescriptions detect: [:desc | desc accessor readSelector == aSymbol] ifNone: [].
		currentDescription isNil
			ifFalse: [| oldIndex newDescription |
					newDescription := self defaultDescriptionOn: aSymbol.
					newDescription isNil ifFalse: [
						oldIndex := self attributeContainer children indexOf: currentDescription.
						self descriptionAt: oldIndex put: newDescription ] ]
			ifTrue: [self addDescription: (self defaultDescriptionOn: aSymbol)]].
	^self attributeDescriptions
! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 09:40'!
canCreateSubclass
	^true! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/01/2008 11:25'!
canDelete
	self subclasses isEmpty ifFalse: [ ^false ].
	(SGSystem hasInstancesOf: name) ifTrue: [^false].
	^true! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:18'!
canEdit
	^self isBasic not! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/07/2008 06:47'!
changeDescription: anAttributeDescription to: newAttributeDescription
	self removeDescription: anAttributeDescription.
	^self addDescription: newAttributeDescription! !

!SGModel class methodsFor: 'querying' stamp: 'obi 11/20/2010 14:25'!
collect: aBlock
	^self instances collect: aBlock! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'obi 6/13/2010 17:19'!
comment: aText
	! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 18:08'!
compile: sourceString classified: aSymbol
	^SGSystem compile: sourceString intoClass: self classified: aSymbol! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 19:48'!
compileAccessingAndUpdatingMethodsForDescription: aDescription
	| sourceStringArray | 
	sourceStringArray := aDescription accessingMethods.
	sourceStringArray do: [:sourceString |
			self 
				compile: sourceString
				classified: #'accessing'].
	sourceStringArray := aDescription updatingMethods.
	sourceStringArray do: [:sourceString |
				self 
					compile: sourceString
					classified: #'updating']
	
! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 19:53'!
compileAccessingMethodsFor: anArrayOfSymbols

	| newLine accessing updating allVarNames varName |
	accessing := #accessing.
	updating := #updating.
	varName := 'newValue'.
	allVarNames := self allInstVarNames.
	[allVarNames includes: varName] whileTrue: [
	  varName := 'z' , varName ].
	newLine:= Character lf asString.
	anArrayOfSymbols do:
	    [ :var |
	      (self compile: (var , newLine , newLine ,
            '   "Return the value of the instance variable ''' , var ,
            '''."' , newLine , '   ^' , var , newLine)
            classified: accessing).

      (self compile: (var , ': ' , varName , newLine , newLine ,
            '   "Modify the value of the instance variable ''' , var ,
            '''."' , newLine , '   ' , var , ' := ' , varName , newLine)
            classified: updating) ]
! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 19:50'!
compileDescriptionMethods

	self compileAccessingMethodsFor: (self attributeDescriptions collect: [:each | each accessor selector]).
 .
	self attributeDescriptions do: [:each | 
		"self compileAccessingAndUpdatingMethodsForDescription: each."
		self compileMethodForDescription: each]! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 19:38'!
compileMethodForDescription: aDescription
	| newLine sourceString |
	newLine := Character lf asString.
	sourceString := WriteStream on: String new.
	sourceString nextPutAll: 'description',(self asLabel: aDescription accessor readSelector), newLine.
	sourceString nextPutAll: '	^', aDescription class name asString, ' new'; nextPutAll: newLine.
	sourceString nextPutAll: '		selectorAccessor: ''', aDescription accessor readSelector asString; nextPutAll: ''';'; nextPutAll: newLine.
	sourceString nextPutAll: '		cssClass: ''', aDescription kind name asString asLowercase; nextPutAll: ''';'; nextPutAll: newLine.
	aDescription properties keysAndValuesDo: [:each :aValue |
				self	methodPartFor: aDescription selector: each value: aValue lf: newLine on: sourceString].
	(aDescription isKindOf: MARelationDescription)
		ifTrue: [self addClassesAccessorFor: aDescription on: sourceString.
				"add default: to fix a magritte bug" 
				sourceString nextPutAll: newLine.
				sourceString nextPutAll: '		default: OrderedCollection new;'.
				sourceString nextPutAll: newLine].
	(aDescription isKindOf: SGTwowayRelationDescription)
		ifTrue: [sourceString nextPutAll: '		targetSelector: #', aDescription targetSelector printString.
				sourceString nextPutAll: newLine].
	sourceString nextPutAll: '		yourself'.
	^self compile: sourceString contents classified: #'accessing-description'
! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 13:19'!
createDefaultDescriptions
	self instVarNames do: [:aSymbol |
			self addDescription: (self defaultDescriptionOn: aSymbol)].
	^self attributeContainer children! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 6/13/2010 18:09'!
createSubclass: aString instVarNames: anArrayOfStrings inDictionary: symbolDict
 "^self subclass: aString
		instVarNames: anArrayOfStrings
		classVars: #()
		classInstVars: #()
		poolDictionaries: #[]
		category: 'Generated Classes'
		inDictionary: symbolDict
		constraints: #[]
		instancesInvariant: false
		isModifiable: false"
		
^SGSystem createSubclass: aString of: self instVarNames: anArrayOfStrings inDictionary: symbolDict category: self defaultCategory! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 6/13/2010 17:39'!
createUserSubclass: aString instVarNames: anArrayOfStrings
 "	| symbolDict |
	symbolDict := System myUserProfile symbolList objectNamed: #UserGlobals."
	^self createSubclass: aString instVarNames: anArrayOfStrings inDictionary: nil ! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/04/2008 10:26'!
currentMandator
	^SGSystem currentMandator! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/04/2008 11:58'!
defaultBatchSize
	^20! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 6/13/2010 17:41'!
defaultCategory
	^'Generated Classes'! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 6/16/2010 21:56'!
defaultCommandColumn
	| column |
	column := SGCommandColumn new.
	self defaultCommandsOn: column.
	self deleteCommandOn: column.
	^column! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 6/16/2010 21:56'!
defaultCommandsOn: column
	column addCommand: [:comp :model | comp call: model open ] text: 'Edit'
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/11/2008 13:31'!
defaultCssFor: aDescription
	^aDescription kind name asString! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/31/2008 10:58'!
defaultDescriptionOn: aSelector
	| descSelector |
	descSelector := ('description',(self asLabel: aSelector)) asSymbol.
	^(self respondsTo: descSelector)
		ifTrue: [self perform: descSelector]
		ifFalse: [self stringDescriptionOn: aSelector]! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/04/2008 14:21'!
defaultEditActions
	^#()! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/05/2008 16:55'!
defaultListActions
	^Array with: #newEditWithTitle -> 'New'! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/08/2008 05:38'!
defaultOpenAction
	^#openWithTitle! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/20/2010 14:28'!
defaultReport
	^self defaultReportOn: self instancesSorted! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/05/2008 15:56'!
defaultReportOn: instances
	^self defaultReportOn: instances commands:  self defaultCommandColumn
! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 05/12/2009 12:38'!
defaultReportOn: instances commands: commandColumn
	| report |
	report := MAReport new
				rowPeriod: 1;
				rows: instances;
				batchSize: self defaultBatchSize.
	self noneRelationDescriptions do: [:desc | report addColumnDescription: desc ].
	report addColumn: commandColumn.
	^report! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/08/2008 05:38'!
defaultShowAction
	^#showWithTitle! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:57'!
defaultSortBlock
	^[:a :b | a displayName < b displayName]! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 6/16/2010 21:53'!
deleteCommandOn: column
	column
		addCommand: [:comp :model | 
			(comp lightbox: 
					(WAYesOrNoDialog new
						addMessage: 'Delete object: ', model displayString;
						yourself)) 
					ifTrue: [comp rows remove: model.
							comp refresh.
							model discard] ] text: 'Discard'! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:23'!
description
	"use cached container"
	^self attributeContainer! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 12:17'!
descriptionAt: anIndex put: anAttributeDescription
	^self attributeContainer children at: anIndex put: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/20/2010 15:12'!
descriptionContainer
	"Return the default description container."

	^ MAContainer new
		label: self label;
		componentRenderer: SGComponentRenderer
		yourself! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/16/2009 10:49'!
descriptionForAttribute: anAttribute
	^self attributeContainer children detect: [:desc | desc accessor readSelector == anAttribute] ifNone: []! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 6/15/2010 22:33'!
descriptionOn: aSelector type: aClass
	^aClass new
		cssClass: aClass defaultKind asString asLowercase;
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'querying' stamp: 'obi 10/26/2008 01:01'!
detect: aBlock
	^self detect: aBlock ifNone: []! !

!SGModel class methodsFor: 'querying' stamp: 'obi 11/20/2010 14:26'!
detect: aBlock ifNone: otherBlock
	^self instances detect: aBlock ifNone: otherBlock! !

!SGModel class methodsFor: 'printing' stamp: 'obi 11/21/2010 10:47'!
displayStringClass
	^name asString copyFrom: 3 to: name size! !

!SGModel class methodsFor: 'querying' stamp: 'obi 11/20/2010 14:25'!
do: aBlock
	^self instances do: aBlock! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/01/2008 10:27'!
edit
	^SGEditClassPage on: self! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 14:36'!
editorClass
	^SGSystem classNamed: self editorClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 14:36'!
editorClassSymbol
	^(name, 'EditorComponent') asSymbol! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/04/2008 12:14'!
fullDescription
	| newContainer |
	newContainer := self descriptionContainer.
	newContainer setChildren: self allAttributeDescriptions.
	^newContainer
	! !

!SGModel class methodsFor: 'initialization' stamp: 'obi 10/31/2008 11:33'!
initialize
	self withAllSubclassesDo: [:cl | cl isBasic ifTrue: [cl resetDescriptions]]! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:25'!
instances
	^self currentMandator instancesAt: name! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:26'!
instancesSize
	^self instances size! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/21/2010 13:58'!
instancesSorted
	^self instances asSortedCollection: self defaultSortBlock! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:33'!
integerDescriptionOn: aSelector
	^MANumberDescription new
		cssClass: 'number';
		label: (self asLabel: aSelector asString);
		priority: 1;
		default: 0;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:18'!
isBasic
	^name == #SGModel! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/31/2008 15:07'!
keyAttribute
	^self allInstVarNames first! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 05:04'!
listClass
	^SGSystem classNamed: self listClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 05:04'!
listClassSymbol
	^(name, 'ListComponent') asSymbol! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:32'!
memoDescriptionOn: aSelector
	^MAMemoDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 6/13/2010 16:22'!
meta
	Meta ifNil: [Meta := Dictionary new].
	^Meta! !

!SGModel class methodsFor: 'accessing' stamp: 'go 10/25/2008 10:33'!
meta: aMetaDict
	Meta := aMetaDict! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'obi 10/28/2008 11:39'!
metaAtKey: aKey ifAbsent: aBlock
	^self meta at: aKey ifAbsent: aBlock! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'obi 10/28/2008 12:42'!
metaAtKey: aKey put: anObject
	^self meta at: aKey put: anObject! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 6/13/2010 19:39'!
methodPartFor: aDescription selector: aSelector value: aValue lf: newLine on: sourceString
	aValue isNil
			ifFalse: [
				((aValue isKindOf: Collection) not or: [aValue isKindOf: String])
					ifTrue: [sourceString nextPutAll: '		', aSelector asString,': ', aValue  printString; nextPutAll: ';'; nextPutAll: newLine]].! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 11/01/2008 11:13'!
migrateInstances: instances to: anotherClass

"Override to enable commits during migration of large collections"
"extra commits are not allowed atm"


! !

!SGModel class methodsFor: 'private' stamp: 'obi 6/13/2010 20:19'!
mySuperClasses

"Returns an Array of all superclasses up to SGModel"

| result currClass |
result:= OrderedCollection new.
(self name == #SGModel)
  ifTrue: [^ result]
  ifFalse: [
    currClass := self superclass.
    [ currClass == SGModel ] whileFalse: [
      result add: currClass.
      currClass := currClass superclass.
    ].
  ].
^result
! !

!SGModel class methodsFor: 'instance creation' stamp: 'obi 11/21/2010 19:57'!
new
	| newObject |
	newObject := super new.
	newObject isPersistent ifTrue: [self add: newObject ] .
	^newObject! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/04/2008 12:02'!
newEdit
	^self newOpen! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/05/2008 16:57'!
newEditWithTitle
	^self new openWithTitle! !

!SGModel class methodsFor: 'public' stamp: 'obi 10/31/2008 15:41'!
newOpen
	^self new open! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 13:43'!
noneBasicClasses
	^self allClasses select: [:cl | cl isBasic not]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/12/2009 12:38'!
noneRelationDescriptions
	^self allAttributeDescriptions select: [:desc | desc kind ~~ Collection]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:31'!
passwordDescriptionOn: aSelector
	^MAPasswordDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 6/16/2010 20:51'!
projectCommandColumn
	^SGCommandColumn new
			addCommand: [:comp :model | comp call: model showWithTitle ] text: 'Show';
			addCommand: [:comp :model | comp call: model openWithTitle ] text: 'Edit';
			addCommand: [:comp :model | 
				(comp lightbox: (WAYesOrNoDialog new
						addMessage: 'Delete object: ', model displayString;
						yourself) ) 
						ifTrue: [comp rows remove: model.
							comp refresh.
							model discard] ] text: 'Discard';
			yourself! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/20/2010 14:28'!
projectReport
	^self projectReportOn: self instancesSorted! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/05/2008 15:58'!
projectReportOn: instances
	^self defaultReportOn: instances commands:  self projectCommandColumn
! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:33'!
relationDescriptionOn: aSelector
	^MAToManyRelationDescription new
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'adding-removing' stamp: 'obi 12/20/2008 12:35'!
remove: anObject
	^self currentMandator remove: anObject! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/03/2008 12:03'!
removeAttributeContainer
	self meta removeKey: #attributeContainer ifAbsent: []! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 11:45'!
removeDescription: anAttributeDescription
	^self attributeContainer remove: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 12:04'!
resetDescriptions
	self removeAttributeContainer.
	self setDescriptions: OrderedCollection new.
	^self updateDescriptions
! !

!SGModel class methodsFor: 'querying' stamp: 'obi 11/20/2010 14:26'!
safelyDo: aBlock
	^self instances copy do: aBlock! !

!SGModel class methodsFor: 'querying' stamp: 'obi 11/20/2010 14:26'!
select: aBlock
	^self instances select: aBlock! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:19'!
setDescriptions: descriptionColl
	self attributeContainer setChildren: descriptionColl! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:31'!
stringDescriptionOn: aSelector
	^MAStringDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 11/04/2008 10:57'!
subclass: aString instVarNames: anArrayOfStrings

	^SGSystem redefineClassNamed: aString with: [
		self createUserSubclass: aString instVarNames: anArrayOfStrings ].! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 6/14/2010 23:18'!
updateDescriptions
	| currentDescriptions theInstVars |
	currentDescriptions := self attributeDescriptions.
	theInstVars := self instVarNames collect: [:each | each asSymbol ].
	theInstVars do: [:aSymbol |
		(currentDescriptions detect: [:desc | desc accessor readSelector == aSymbol] ifNone: []) isNil
			ifTrue: [self addDescription: (self defaultDescriptionOn: aSymbol)]].
	currentDescriptions copy do: [:desc |
		(theInstVars includes: desc accessor readSelector)
			ifFalse: [self attributeContainer remove: desc] ].
	^self attributeDescriptions
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:10'!
viewClass
	^SGSystem classNamed: self viewClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:10'!
viewClassSymbol
	^(name, 'ViewComponent') asSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 6/15/2010 22:49'!
withAllSubclasses
	^super withAllSubclasses select: [:each | (SGSystem classNamed: each name) notNil ]! !

!SGModel methodsFor: 'accessing' stamp: 'obi 6/15/2010 22:59'!
<= aModel
	^aModel displayName <= aModel displayName! !

!SGModel methodsFor: 'accessing' stamp: 'obi 05/05/2009 12:56'!
accessorFor: anAttribute
	^self class accessorFor: anAttribute! !

!SGModel methodsFor: 'accessing' stamp: 'obi 01/02/2009 10:22'!
asComponent
	^ self class fullDescription asComponentOn: self! !

!SGModel methodsFor: 'printing' stamp: 'obi 12/29/2008 12:21'!
asString
	^self displayString! !

!SGModel methodsFor: 'accessing' stamp: 'obi 10/31/2008 11:43'!
attributeDescriptions
	^self class attributeDescriptions! !

!SGModel methodsFor: 'removing' stamp: 'obi 05/05/2009 12:44'!
basicDiscard
	self release.
	self class remove: self! !

!SGModel methodsFor: 'testing' stamp: 'obi 10/31/2008 15:34'!
canDiscard
	^true! !

!SGModel methodsFor: 'removing' stamp: 'obi 10/31/2008 15:41'!
discard
	self canDiscard
		ifTrue: [self basicDiscard]! !

!SGModel methodsFor: 'printing' stamp: 'obi 11/25/2008 14:20'!
displayName
	^(self instVarAt: 1) asString! !

!SGModel methodsFor: 'printing' stamp: 'obi 11/21/2010 11:08'!
displayString
	^self displayName , ' (', self class displayStringClass ,')'! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 03/27/2009 11:18'!
initialize
	"some hacks to avoid using always the same collection"
	self class attributeDescriptions do: [:desc | 
		desc kind = Collection
			ifTrue: [desc accessor write: OrderedCollection new to: self ]
			ifFalse: [self initializeWith: desc accessor using: desc]].
	self postInitialize
	! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 11/07/2008 05:56'!
initializeWith: maAccessor using: aDescription
"only init nil values"
	(maAccessor canWrite: self)
		ifTrue: [ maAccessor write: aDescription default to: self ] 
	! !

!SGModel methodsFor: 'testing' stamp: 'obi 11/20/2010 14:29'!
isPersistent
	^true! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 05/17/2009 11:50'!
open
	^self asComponent addValidatedForm! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/08/2008 10:37'!
openWithTitle
	^self class editorClass on: self! !

!SGModel methodsFor: 'post-actions' stamp: 'obi 11/07/2008 06:14'!
postActions
	"override in subclasses if you need some one"! !

!SGModel methodsFor: 'post-actions' stamp: 'obi 11/07/2008 06:15'!
postInitialize
	"override in subclasses if you need some one"! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 05/05/2009 12:45'!
release
	"release all instVars"
	self class allAttributeDescriptions do: [:desc | desc accessor write: nil to: self ].

	! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 11/07/2008 05:57'!
safeInitialize
"only init nil values"
	self class attributeDescriptions do: [:desc | | maAccessor |
			maAccessor := desc accessor.
			(self perform: maAccessor readSelector)
				isNil ifTrue: [self initializeWith: maAccessor using: desc] ]
	! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/05/2008 16:07'!
show
	^self asComponent addValidatedSwitch! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/08/2008 10:37'!
showWithTitle
	^ self class viewClass on: self
! !

SGModel subclass: #SGProject
	instanceVariableNames: 'name path description modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGProject class methodsFor: 'testing' stamp: 'obi 6/20/2010 21:07'!
canCreateSubclass
	^false! !

!SGProject class methodsFor: 'accessing' stamp: 'obi 11/05/2008 10:34'!
currentMandator
	"always use the default mandator"
	^SGMandator default! !

!SGProject class methodsFor: 'accessing-actions' stamp: 'obi 6/16/2010 22:21'!
defaultCommandsOn: column
	super defaultCommandsOn: column.
	column addCommand: [:comp :model | comp requestContext redirectTo: model entryPoint ] text: 'Open'
! !

!SGProject class methodsFor: 'descriptions' stamp: 'obi 11/05/2008 10:30'!
descriptionDescription
	| desc |
	desc := self memoDescriptionOn: #description.
	^desc! !

!SGProject class methodsFor: 'descriptions' stamp: 'obi 11/05/2008 11:20'!
descriptionModelClass
	| desc |
	desc := self stringDescriptionOn: #modelClass.
	desc required: true.
	^desc! !

!SGProject class methodsFor: 'descriptions' stamp: 'obi 11/05/2008 10:28'!
descriptionName
	| desc |
	desc := self stringDescriptionOn: #name.
	desc required: true.
	^desc! !

!SGProject class methodsFor: 'descriptions' stamp: 'obi 11/07/2008 07:28'!
descriptionPath
	| desc |
	desc := self stringDescriptionOn: #path.
	desc default: ''.
	^desc! !

!SGProject class methodsFor: 'testing' stamp: 'obi 11/05/2008 10:31'!
isBasic
	^true! !

!SGProject methodsFor: 'private' stamp: 'obi 6/16/2010 21:04'!
application
	^WADispatcher default handlerAt: self entryPoint! !

!SGProject methodsFor: 'actions' stamp: 'obi 12/29/2008 12:39'!
basicDiscard
	| anApplication |
	modelClass isEmpty
		ifFalse: [anApplication := self application.
				anApplication isNil ifFalse: [WADispatcher default unregister: anApplication] ].
	super basicDiscard.
	! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/25/2008 14:29'!
componentClass
	^SGSystem classNamed: self componentClassName asSymbol
! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/25/2008 14:29'!
componentClassName
	^modelClass ,'Component'
! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/05/2008 10:51'!
description
	^description 
! !

!SGProject methodsFor: 'Updating' stamp: 'obi 11/05/2008 10:51'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue
! !

!SGProject methodsFor: 'private' stamp: 'obi 11/08/2008 09:36'!
entryPoint
	| aPath |
	aPath := self path.
	aPath isEmpty ifTrue: [^'/',self name].
	^(aPath first == $/ )
		ifTrue: [(aPath size > 1 ifTrue: [aPath,'/'] ifFalse: [aPath]), self name]
		ifFalse: ['/', aPath, '/', self name]
		! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/05/2008 11:26'!
modelClass
	^modelClass 
! !

!SGProject methodsFor: 'Updating' stamp: 'obi 11/05/2008 11:26'!
modelClass: newValue

   "Modify the value of the instance variable 'modelClass'."
   modelClass := newValue
! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/05/2008 10:51'!
name
	^name 
! !

!SGProject methodsFor: 'Updating' stamp: 'obi 11/05/2008 10:51'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue
! !

!SGProject methodsFor: 'actions' stamp: 'obi 11/05/2008 10:48'!
open
	^SGProjectPage on: self! !

!SGProject methodsFor: 'Accessing' stamp: 'obi 11/07/2008 07:30'!
path
	path ifNil: [path := ''].
	^path! !

!SGProject methodsFor: 'Updating' stamp: 'obi 11/07/2008 07:27'!
path: newValue

   "Modify the value of the instance variable 'path'."
   path := newValue
! !

!SGProject methodsFor: 'actions' stamp: 'obi 11/08/2008 00:35'!
save
	modelClass isEmpty
		ifFalse: [SGSystem createProjectFor: self named: name]! !

SGModel subclass: #SGTreeModel
	instanceVariableNames: 'parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:32'!
childClasses
	^self allSubclasses! !

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:31'!
descriptionChildren
	^ MAToManyRelationDescription new
		classes: self childClasses;
		accessor: #children;
		label: 'Children';
		default: OrderedCollection new;
		priority: 100;
		visible: false;
		beDefinitive;
		beOrdered;
		yourself! !

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:35'!
descriptionParent
	^ MAToOneRelationDescription new
		classes: self childClasses;
		accessor: #parent;
		label: 'Parent';
		default: nil;
		priority: 50;
		visible: false;
		yourself! !

!SGTreeModel class methodsFor: 'testing' stamp: 'obi 11/01/2008 11:03'!
isBasic
	^name == #SGTreeModel! !

!SGTreeModel methodsFor: 'public' stamp: 'obi 11/07/2008 07:17'!
allChildren
	| result |
	result := OrderedCollection new.
	self allChildrenInto: result.
	^result! !

!SGTreeModel methodsFor: 'public' stamp: 'obi 11/07/2008 07:16'!
allChildrenInto: aCollection
	aCollection addAll: children.
	children do: [:each | each allChildrenInto: aCollection]! !

!SGTreeModel methodsFor: 'removing' stamp: 'obi 11/07/2008 07:15'!
basicDiscard
	super basicDiscard.
	self children do: [:each | each basicDiscard].
	parent := nil.
	children size: 0! !

!SGTreeModel methodsFor: 'Accessing' stamp: 'obi 11/01/2008 08:29'!
children

   "Return the value of the instance variable 'children'."
   ^children
! !

!SGTreeModel methodsFor: 'Updating' stamp: 'obi 11/01/2008 08:29'!
children: newValue

   "Modify the value of the instance variable 'children'."
   children := newValue
! !

!SGTreeModel methodsFor: 'printing' stamp: 'obi 11/05/2008 10:00'!
displayString
	^(self instVarAt: 3) asString , ' (', self class name asString,')'! !

!SGTreeModel methodsFor: 'Accessing' stamp: 'obi 11/01/2008 08:29'!
parent

   "Return the value of the instance variable 'parent'."
   ^parent
! !

!SGTreeModel methodsFor: 'Updating' stamp: 'obi 11/01/2008 08:29'!
parent: newValue

   "Modify the value of the instance variable 'parent'."
   parent := newValue
! !

SGModel subclass: #SGUser
	instanceVariableNames: 'loginName password lastName firstName email defaultMandator allowedMandators groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding-Model'!

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 6/13/2010 20:10'!
descriptionAllowedMandators
	^MAToManyRelationDescription new
		selectorAccessor: 'allowedMandators';
		cssClass: 'collection';
		definitive: true;
		priority: 100;
		ordered: true;
		label: 'Allowed';
		visible: false;
		classes: (OrderedCollection with: SGMandator);
		default: OrderedCollection new;
		yourself! !

!SGUser class methodsFor: 'descriptions' stamp: 'obi 11/21/2010 14:05'!
descriptionDefaultMandator
	^SGSingleOptionDescription new
		options: [SGMandator instancesSorted];
		accessor: #defaultMandator;
		label: 'Default tenant';
		default: SGMandator default;
		group: 'User';
		priority: 100;
		visible: true;
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/21/2010 10:18'!
descriptionEmail
	^MAStringDescription new
		selectorAccessor: 'email';
		cssClass: 'string';
		priority: 3;
		group: 'User';
		label: 'Email';
		comment: 'Enter a valid email address'
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/20/2010 19:47'!
descriptionFirstName
	^MAStringDescription new
		selectorAccessor: 'firstName';
		cssClass: 'string';
		priority: 2;
		group: 'User';
		label: 'First Name';
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/20/2010 19:47'!
descriptionGroups
	^SGTwowayRelationDescription new
		selectorAccessor: 'groups';
		targetSelector: #users;
		cssClass: 'object';
		priority: 100;
		label: 'Groups';
		group: 'Relations';
		visible: true;
		classes: (OrderedCollection with: SGGroup);
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/20/2010 19:48'!
descriptionLastName
	^MAStringDescription new
		selectorAccessor: 'lastName';
		cssClass: 'string';
		priority: 2;
		group: 'User';
		label: 'Last Name';
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/20/2010 19:45'!
descriptionLoginName
	^MAStringDescription new
		selectorAccessor: 'loginName';
		cssClass: 'string';
		required: true;
		priority: 1;
		group: 'Credentials';
		label: 'Login Name';
		yourself! !

!SGUser class methodsFor: 'accessing-description' stamp: 'obi 11/20/2010 19:46'!
descriptionPassword
	^MAPasswordDescription new
		selectorAccessor: 'password';
		cssClass: 'string';
		required: true;
		priority: 1;
		group: 'Credentials';
		label: 'Password';
		yourself! !

!SGUser class methodsFor: 'accessing' stamp: 'obi 10/31/2008 09:32'!
isBasic
	^name == #SGUser! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
allowedMandators

   "Return the value of the instance variable 'allowedMandators'."
   ^allowedMandators
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
allowedMandators: newValue

   "Modify the value of the instance variable 'allowedMandators'."
   allowedMandators := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
defaultMandator

   "Return the value of the instance variable 'defaultMandator'."
   ^defaultMandator
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
defaultMandator: newValue

   "Modify the value of the instance variable 'defaultMandator'."
   defaultMandator := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
email

   "Return the value of the instance variable 'email'."
   ^email
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
email: newValue

   "Modify the value of the instance variable 'email'."
   email := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
firstName

   "Return the value of the instance variable 'firstName'."
   ^firstName
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
firstName: newValue

   "Modify the value of the instance variable 'firstName'."
   firstName := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:48'!
groups

   "Return the value of the instance variable 'groups'."
   ^groups
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:48'!
groups: newValue

   "Modify the value of the instance variable 'groups'."
   groups := newValue
! !

!SGUser methodsFor: 'updating' stamp: 'obi 05/05/2009 13:14'!
groupsAdd: aModel

	(self accessorFor: #groups) write: aModel to: self! !

!SGUser methodsFor: 'updating' stamp: 'obi 05/05/2009 13:14'!
groupsRemove: aModel

	(self accessorFor: #groups) remove: aModel from: self! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
lastName

   "Return the value of the instance variable 'lastName'."
   ^lastName
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
lastName: newValue

   "Modify the value of the instance variable 'lastName'."
   lastName := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
loginName

   "Return the value of the instance variable 'loginName'."
   ^loginName
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
loginName: newValue

   "Modify the value of the instance variable 'loginName'."
   loginName := newValue
! !

!SGUser methodsFor: 'accessing' stamp: 'obi 04/19/2009 10:51'!
password

   "Return the value of the instance variable 'password'."
   ^password
! !

!SGUser methodsFor: 'updating' stamp: 'obi 04/19/2009 10:51'!
password: newValue

   "Modify the value of the instance variable 'password'."
   password := newValue
! !

Object subclass: #SGObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

SGObject subclass: #SGCommand
	instanceVariableNames: 'requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCommand class methodsFor: 'instance creation' stamp: 'obi 6/20/2010 16:52'!
on: aComponent 
	^self new requestor: aComponent; yourself! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:36'!
cancelIcon
	^'ui-icon-close'
! !

!SGCommand methodsFor: 'public' stamp: 'obi 6/20/2010 14:33'!
executeOn: s! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:29'!
icon
	^''! !

!SGCommand methodsFor: 'testing' stamp: 'obi 6/20/2010 14:32'!
isEnabled
	^ true! !

!SGCommand methodsFor: 'testing' stamp: 'obi 6/20/2010 14:32'!
isVisible
	^ true! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:32'!
label
	self subclassResponsibility
! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:36'!
okIcon
	^'ui-icon-check'
! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:55'!
preOnClick
	^JSStream on: 'true'! !

!SGCommand methodsFor: 'rendering' stamp: 'obi 6/20/2010 14:37'!
renderOn: html
	| aTag iconName |
	iconName := self icon.
	aTag := html anchor.
	iconName isEmpty ifFalse: [aTag script: (html jQuery this button primaryIcon: self icon )].
	aTag
		onClick: (html jQuery ajax script: [:s | self executeOn: s ]);
		title: self title;
		with: self label
! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:15'!
requestor
	^ requestor! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:15'!
requestor: anObject
	requestor := anObject! !

!SGCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:32'!
title
	"Override this and return a string or a text for the fly-by-help (tooltip)"
	^ nil! !

SGCommand subclass: #SGFormCommand
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

SGFormCommand subclass: #SGCmdCreateClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCmdCreateClass methodsFor: 'public' stamp: 'obi 6/20/2010 18:01'!
executeOn: script
	| newClass | 
	requestor selection isNil
		ifFalse: [newClass := requestor selection subclass: requestor name instVarNames: (requestor attributesArray).
			newClass isNil ifFalse: [
				requestor ajaxAdd: newClass edit on: script]]! !

!SGCmdCreateClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 16:41'!
icon
	^self okIcon! !

!SGCmdCreateClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 16:41'!
label
	^'Create'! !

!SGCmdCreateClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 16:41'!
title
	^'Create subclass'! !

SGFormCommand subclass: #SGCmdRemoveClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCmdRemoveClass methodsFor: 'public' stamp: 'obi 6/20/2010 21:05'!
executeOn: script
	| theClass |
	theClass := requestor theClass.
	theClass isNil ifFalse: [
				"theClass canDelete ifFalse: [^self inform: 'Delete is not possible -> Class has instances!!']."
				SGSystem removeClassNamed: theClass name check: false ].
	requestor ajaxBackOn: script! !

!SGCmdRemoveClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:37'!
icon
	^'ui-icon-minus'! !

!SGCmdRemoveClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:33'!
label
	^'Remove'! !

!SGCmdRemoveClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:59'!
preOnClick
	^JSStream on: 'confirm("Really delete this class?")'! !

!SGCmdRemoveClass methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:38'!
title
	^'Remove class from system'! !

SGFormCommand subclass: #SGCmdSave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCmdSave methodsFor: 'public' stamp: 'obi 6/20/2010 20:33'!
executeOn: script
	requestor ajaxShow: requestor on: script! !

!SGCmdSave methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:35'!
icon
	^self okIcon! !

!SGCmdSave methodsFor: 'accessing' stamp: 'obi 6/20/2010 20:38'!
label
	^'Save'! !

SGCmdSave subclass: #SGCmdSaveClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGCmdSaveClass methodsFor: 'public' stamp: 'obi 6/20/2010 20:47'!
executeOn: script
	| theClass |
	theClass := requestor theClass.
	theClass isNil ifFalse: [
		theClass comment: requestor classComment.
		requestor attributesChanged
			ifTrue: [
				theClass := theClass superclass subclass: theClass name instVarNames: requestor attributesArray.
				requestor theClass: theClass ].
		theClass compileDescriptionMethods].
	super executeOn: script! !

!SGFormCommand class methodsFor: 'instance creation' stamp: 'obi 6/20/2010 18:09'!
on: aComponent id: formId
	^self new requestor: aComponent; id: formId; yourself! !

!SGFormCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 18:30'!
id: anID
	id := anID ! !

!SGFormCommand methodsFor: 'rendering' stamp: 'obi 6/20/2010 20:54'!
renderOn: html
	| aTag iconName |
	iconName := self icon.
	aTag := html anchor.
	iconName isEmpty
		ifTrue: [ aTag script: html jQuery this button ]
		ifFalse: [ aTag script: (html jQuery this button primaryIcon: self icon )].
	aTag
		onClick: (self preOnClick then: (html jQuery ajax serializeForm; script: [:s | self executeOn: s ]));
		title: self title;
		with: self label
! !

SGCommand subclass: #SGPluggableCommand
	instanceVariableNames: 'action visible enabled label icon title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
action
	^ action! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
action: anObject
	action := anObject! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
enabled
	^ enabled! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
enabled: anObject
	enabled := anObject! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
icon
	^ icon! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
icon: anObject
	icon := anObject! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
label
	^ label! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:14'!
label: anObject
	label := anObject! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:15'!
title
	^ title! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:15'!
title: anObject
	title := anObject! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:16'!
visible
	^ visible! !

!SGPluggableCommand methodsFor: 'accessing' stamp: 'obi 6/20/2010 14:16'!
visible: anObject
	visible := anObject! !

SGObject subclass: #SGRenderableItem
	instanceVariableNames: 'label selected action component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

SGRenderableItem subclass: #SGMenuItem
	instanceVariableNames: 'subItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGMenuItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 15:12'!
label: aLabel
	^self on: nil label: aLabel! !

!SGMenuItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 15:11'!
on: anActionBlock label: aLabel
	^self new action: anActionBlock; label: aLabel; yourself! !

!SGMenuItem methodsFor: 'public' stamp: 'obi 10/30/2008 15:04'!
add: anItem
	subItems add: anItem! !

!SGMenuItem methodsFor: 'Accessing' stamp: 'obi 11/22/2010 22:44'!
first
   ^subItems first
! !

!SGMenuItem methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:28'!
initialize
	super initialize.
	subItems := OrderedCollection new! !

!SGMenuItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
subItems

   "Return the value of the instance variable 'subItems'."
   ^subItems
! !

!SGMenuItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
subItems: newValue

   "Modify the value of the instance variable 'subItems'."
   subItems := newValue
! !

!SGRenderableItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 16:13'!
label: aLabel
	^self on: nil label: aLabel! !

!SGRenderableItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 16:13'!
on: anActionBlock label: aLabel
	^self new action: anActionBlock; label: aLabel; yourself! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
action

   "Return the value of the instance variable 'action'."
   ^action
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
action: newValue

   "Modify the value of the instance variable 'action'."
   action := newValue
! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/31/2008 12:05'!
component
	component ifNil: [self execute].
 	^component
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
component: newValue

   "Modify the value of the instance variable 'component'."
   component := newValue
! !

!SGRenderableItem methodsFor: 'public' stamp: 'obi 10/31/2008 12:05'!
execute
	component := action value.
	^component
! !

!SGRenderableItem methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:28'!
initialize
	super initialize.
	selected := false.! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
label

   "Return the value of the instance variable 'label'."
   ^label
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue
! !

!SGRenderableItem methodsFor: 'rendering' stamp: 'obi 10/30/2008 15:59'!
renderOn: html
	action ifNotNil: [
		html render: self component]! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
selected

   "Return the value of the instance variable 'selected'."
   ^selected
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
selected: newValue

   "Modify the value of the instance variable 'selected'."
   selected := newValue
! !

SGRenderableItem subclass: #SGToolbarItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

Object subclass: #SGSystem
	instanceVariableNames: ''
	classVariableNames: 'Current Mandator Types Users'
	poolDictionaries: ''
	category: 'Seaside-Scaffolding'!

!SGSystem class methodsFor: 'accessing-types' stamp: 'obi 10/26/2008 12:25'!
addType: aType
	self types add: aType! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 6/13/2010 16:26'!
classNamed: aName
	^Smalltalk classNamed: aName
	"System myUserProfile symbolList objectNamed: aName"! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/13/2010 18:07'!
compile: sourceString intoClass: aClass classified: aSymbol
	^GRPlatform current
			compile: sourceString
			into: aClass
			classified: aSymbol! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/13/2010 19:01'!
copyMethodsFrom: originalClass to: newClass dictionaries: ns

	originalClass selectors do: [:aSelector |
		  newClass copy: aSelector from: originalClass classified: (originalClass categoryForSelector: aSelector)].
	originalClass class selectors do: [:aSelector |
		  newClass class copy: aSelector from: originalClass class classified: (originalClass class categoryForSelector: aSelector)]
! !

!SGSystem class methodsFor: 'private-project' stamp: 'obi 6/13/2010 18:10'!
createComponentClassNamed: className superclass: aSuperClass
	| aClass |
	aClass := self classNamed: className.
	aClass isNil
		ifTrue: [ aClass := self createSubclass: className of: aSuperClass instVarNames: #() inDictionary: nil category: self projectCategory ]. 	^aClass! !

!SGSystem class methodsFor: 'public-project' stamp: 'obi 6/13/2010 18:02'!
createProjectFor: aProject named: aName
	| aModelClassName aClass aModelClass componentClasses |
	aModelClassName := aProject modelClass.
	aModelClass := self classNamed: aModelClassName.
	
	"create class for my project component"
	aClass := self createComponentClassNamed: aModelClassName, 'Component' superclass: SGProjectComponent.
	componentClasses := OrderedCollection with: aClass.
	
	"create class for my editor component"
	componentClasses add: (self createComponentClassNamed: aModelClass editorClassSymbol superclass: SGEditorComponent).
	
	"create class for my view component"
	componentClasses add: (self createComponentClassNamed: aModelClass viewClassSymbol superclass: SGViewComponent).
	
	"create class for my list component"
	componentClasses add: (self createComponentClassNamed: aModelClass listClassSymbol superclass: SGListComponent).
	
	"register my application"
	(WAAdmin register: aClass asApplicationAt: aProject entryPoint)
		addLibrary: PTDeploymentLibrary;
		addLibrary: SUDeploymentLibrary;
		addLibrary: SGProjectLibrary;
	     	preferenceAt: #sessionClass put: SGSession;
		yourself.
		
	"create default methods for each component class"
	self createProjectMethodsFor: aModelClass on: componentClasses! !

!SGSystem class methodsFor: 'public-project' stamp: 'obi 6/13/2010 18:11'!
createProjectMethodsFor: aModelClass on: componentClasses 
	| newLine |
	newLine := Character lf asString.
	componentClasses do: [:aComponentClass | 
			self compile: 'modelClass',newLine, '	^', aModelClass name asString
				intoClass: aComponentClass class
				classified: #accessing]
! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/14/2010 23:06'!
createSubclass: aString of: superClass instVarNames: anArrayOfStrings inDictionary: symbolDict category: cat
 "^self subclass: aString
		instVarNames: anArrayOfStrings
		classVars: #()
		classInstVars: #()
		poolDictionaries: #[]
		category: 'Generated Classes'
		inDictionary: symbolDict
		constraints: #[]
		instancesInvariant: false
		isModifiable: false"
^superClass subclass: aString asSymbol
	instanceVariableNames: anArrayOfStrings asArray
	classVariableNames: ''
	poolDictionaries: ''
	category: cat! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/20/2010 15:28'!
currentMandator
	^ [WACurrentRequestContext value session mandator] on: Error do: [:ex |
			Mandator == nil 
				ifTrue: [ SGMandator default ]
				ifFalse: [ Mandator ]].	
! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 6/14/2010 22:31'!
currentMandator: aMandator
	| aSession |
	aSession := WACurrentRequestContext value session.
	aSession isNil 
		ifTrue: [Mandator := aMandator]
		ifFalse: [aSession mandator: aMandator]! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 10/26/2008 11:11'!
hasInstancesOf: className
	SGMandator allDo: [:aMandator | (aMandator hasInstancesOf: className) ifTrue: [^true] ].
	^false! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/22/2010 21:50'!
instanceCollectionClass
	"we should use RcIdentityBag for GemStone"
	^OrderedCollection! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 10/29/2008 14:59'!
mandators
	^SGMandator list! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/13/2010 16:24'!
migrateInstancesWithSubclassesOf: topClass

	"Get the instances from all Mandators"
	"Migrate them all."
	"Do commits during migration of more than 10000 instances"
	"commit is currently not allowed inside a seaside transaction !!"
	
	"GemStone only"! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 10/29/2008 14:59'!
modelClasses
	^SGModel withAllSubclasses! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 6/13/2010 18:53'!
namespace
	"used for GemStone compatibility"
	"GsSession currentSession symbolList."
	^nil ! !

!SGSystem class methodsFor: 'private-project' stamp: 'obi 6/16/2010 20:45'!
projectCategory
	^'Seaside-Project-Generated'! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/14/2010 22:46'!
redefineClassNamed: aClassName with: aBlock
	"after redefining the class migrate self and all subclasses and also do a recompile of my accessors and my descriptions"
	"remove also the old class versions afterwards"
	| originalClass classOrganizer cls |
	originalClass := self classNamed: aClassName asSymbol.
	originalClass ~~ nil 
		ifTrue: [ 
			"pre-create the classOrganizer, so that original subclasses are preserved."
			"classOrganizer := ClassOrganizer cachedOrganizer "].
	cls := aBlock value.
	cls == nil
		ifTrue: [ ^nil ].
	
	originalClass ~~ nil
		ifTrue: [ self copyMethodsFrom: originalClass to: cls	dictionaries: self namespace.
			"copy meta data"
			 cls meta: originalClass meta.
			"cls comment: originalClass comment."
			"force redefinition of existing subclasses"
			self redefineSubclassesOf: originalClass using: classOrganizer.
			self migrateInstancesWithSubclassesOf: cls.
			"cls classHistory removeVersion: originalClass"].
	
	"create accessors by default, but delete old ones"
	(cls allMethodsInCategory: #accessing) do: [:m | cls removeSelector: m].
	(cls allMethodsInCategory: #updating) do: [:m | cls removeSelector: m].
	cls updateDescriptions.
	cls compileDescriptionMethods.
	^cls! !

!SGSystem class methodsFor: 'migrating' stamp: 'obi 6/13/2010 19:08'!
redefineSubclassesOf: aClass using: aClassOrganizer
"GemStone only ?"
"	(aClassOrganizer subclassesOf: aClass) do: [:subClass | | newClass |
		newClass := (self classNamed: subClass superclass name) createUserSubclass: subClass name instVarNames: subClass instVarNames.
		newClass 
			copyMethodsFrom: subClass 
			dictionaries: self namespace .
		newClass meta: subClass meta.
		newClass comment: subClass comment.
		self redefineSubclassesOf: subClass using: aClassOrganizer ]."! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 11/01/2008 11:26'!
removeClassNamed: aClassName
	^self removeClassNamed: aClassName check: true! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 6/13/2010 18:54'!
removeClassNamed: aClassName check: aBoolean
	"the class should not have any instances and no subclasses"
	| aClass |
	aClass := self classNamed: aClassName asSymbol.
	aClass isNil 
		ifFalse: [
			aBoolean ifTrue: [aClass canDelete ifFalse: [^false]].
			aClass removeFromSystem.
			SGMandator allDo: [:aMandator | aMandator removeClassNamed: aClassName]].
	^true! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/04/2008 07:38'!
sessionStateNumber
	^25! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 10/26/2008 12:26'!
types
	Types isNil ifTrue: [Types := IdentityBag new].
	^Types! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/20/2010 14:26'!
users
	^SGUser instances! !
SGLogin initialize!
SGMain initialize!
SGModel initialize!
